Blame


1 c4296144 2019-05-09 stsp #!/bin/sh
2 c4296144 2019-05-09 stsp #
3 c4296144 2019-05-09 stsp # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 c4296144 2019-05-09 stsp #
5 c4296144 2019-05-09 stsp # Permission to use, copy, modify, and distribute this software for any
6 c4296144 2019-05-09 stsp # purpose with or without fee is hereby granted, provided that the above
7 c4296144 2019-05-09 stsp # copyright notice and this permission notice appear in all copies.
8 c4296144 2019-05-09 stsp #
9 c4296144 2019-05-09 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 c4296144 2019-05-09 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 c4296144 2019-05-09 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 c4296144 2019-05-09 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 c4296144 2019-05-09 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 c4296144 2019-05-09 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 c4296144 2019-05-09 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 c4296144 2019-05-09 stsp
17 c4296144 2019-05-09 stsp . ./common.sh
18 c4296144 2019-05-09 stsp
19 f6cae3ed 2020-09-13 naddy test_commit_basic() {
20 c4296144 2019-05-09 stsp local testroot=`test_init commit_basic`
21 c4296144 2019-05-09 stsp
22 c4296144 2019-05-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
23 c4296144 2019-05-09 stsp ret="$?"
24 c4296144 2019-05-09 stsp if [ "$ret" != "0" ]; then
25 c4296144 2019-05-09 stsp test_done "$testroot" "$ret"
26 c4296144 2019-05-09 stsp return 1
27 c4296144 2019-05-09 stsp fi
28 c4296144 2019-05-09 stsp
29 c4296144 2019-05-09 stsp echo "modified alpha" > $testroot/wt/alpha
30 c4296144 2019-05-09 stsp (cd $testroot/wt && got rm beta >/dev/null)
31 c4296144 2019-05-09 stsp echo "new file" > $testroot/wt/new
32 c4296144 2019-05-09 stsp (cd $testroot/wt && got add new >/dev/null)
33 c4296144 2019-05-09 stsp
34 83a7ae6d 2019-05-10 stsp (cd $testroot/wt && got commit -m 'test commit_basic' > $testroot/stdout)
35 c4296144 2019-05-09 stsp
36 c4296144 2019-05-09 stsp local head_rev=`git_show_head $testroot/repo`
37 afa376bf 2019-05-09 stsp echo "A new" > $testroot/stdout.expected
38 afa376bf 2019-05-09 stsp echo "M alpha" >> $testroot/stdout.expected
39 afa376bf 2019-05-09 stsp echo "D beta" >> $testroot/stdout.expected
40 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
41 c4296144 2019-05-09 stsp
42 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
43 c4296144 2019-05-09 stsp ret="$?"
44 c4296144 2019-05-09 stsp if [ "$ret" != "0" ]; then
45 c4296144 2019-05-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
46 c4296144 2019-05-09 stsp fi
47 c4296144 2019-05-09 stsp test_done "$testroot" "$ret"
48 c4296144 2019-05-09 stsp }
49 c4296144 2019-05-09 stsp
50 f6cae3ed 2020-09-13 naddy test_commit_new_subdir() {
51 baa7dcfa 2019-05-09 stsp local testroot=`test_init commit_new_subdir`
52 baa7dcfa 2019-05-09 stsp
53 baa7dcfa 2019-05-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
54 baa7dcfa 2019-05-09 stsp ret="$?"
55 baa7dcfa 2019-05-09 stsp if [ "$ret" != "0" ]; then
56 baa7dcfa 2019-05-09 stsp test_done "$testroot" "$ret"
57 baa7dcfa 2019-05-09 stsp return 1
58 baa7dcfa 2019-05-09 stsp fi
59 baa7dcfa 2019-05-09 stsp
60 baa7dcfa 2019-05-09 stsp mkdir -p $testroot/wt/d
61 baa7dcfa 2019-05-09 stsp echo "new file" > $testroot/wt/d/new
62 baa7dcfa 2019-05-09 stsp echo "another new file" > $testroot/wt/d/new2
63 baa7dcfa 2019-05-09 stsp (cd $testroot/wt && got add d/new >/dev/null)
64 baa7dcfa 2019-05-09 stsp (cd $testroot/wt && got add d/new2 >/dev/null)
65 baa7dcfa 2019-05-09 stsp
66 baa7dcfa 2019-05-09 stsp (cd $testroot/wt && \
67 baa7dcfa 2019-05-09 stsp got commit -m 'test commit_new_subdir' > $testroot/stdout)
68 baa7dcfa 2019-05-09 stsp
69 baa7dcfa 2019-05-09 stsp local head_rev=`git_show_head $testroot/repo`
70 baa7dcfa 2019-05-09 stsp echo "A d/new" > $testroot/stdout.expected
71 baa7dcfa 2019-05-09 stsp echo "A d/new2" >> $testroot/stdout.expected
72 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
73 baa7dcfa 2019-05-09 stsp
74 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
75 baa7dcfa 2019-05-09 stsp ret="$?"
76 baa7dcfa 2019-05-09 stsp if [ "$ret" != "0" ]; then
77 baa7dcfa 2019-05-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
78 baa7dcfa 2019-05-09 stsp fi
79 baa7dcfa 2019-05-09 stsp test_done "$testroot" "$ret"
80 baa7dcfa 2019-05-09 stsp }
81 baa7dcfa 2019-05-09 stsp
82 f6cae3ed 2020-09-13 naddy test_commit_subdir() {
83 bc70eb79 2019-05-09 stsp local testroot=`test_init commit_subdir`
84 bc70eb79 2019-05-09 stsp
85 bc70eb79 2019-05-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
86 bc70eb79 2019-05-09 stsp ret="$?"
87 bc70eb79 2019-05-09 stsp if [ "$ret" != "0" ]; then
88 bc70eb79 2019-05-09 stsp test_done "$testroot" "$ret"
89 bc70eb79 2019-05-09 stsp return 1
90 bc70eb79 2019-05-09 stsp fi
91 bc70eb79 2019-05-09 stsp
92 bc70eb79 2019-05-09 stsp echo "modified alpha" > $testroot/wt/alpha
93 bc70eb79 2019-05-09 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
94 bc70eb79 2019-05-09 stsp
95 bc70eb79 2019-05-09 stsp (cd $testroot/wt && \
96 bc70eb79 2019-05-09 stsp got commit -m 'test commit_subdir' epsilon > $testroot/stdout)
97 bc70eb79 2019-05-09 stsp
98 bc70eb79 2019-05-09 stsp local head_rev=`git_show_head $testroot/repo`
99 bc70eb79 2019-05-09 stsp echo "M epsilon/zeta" >> $testroot/stdout.expected
100 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
101 bc70eb79 2019-05-09 stsp
102 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
103 bc70eb79 2019-05-09 stsp ret="$?"
104 bc70eb79 2019-05-09 stsp if [ "$ret" != "0" ]; then
105 bc70eb79 2019-05-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
106 bc70eb79 2019-05-09 stsp fi
107 bc70eb79 2019-05-09 stsp test_done "$testroot" "$ret"
108 bc70eb79 2019-05-09 stsp }
109 bc70eb79 2019-05-09 stsp
110 f6cae3ed 2020-09-13 naddy test_commit_single_file() {
111 5bbcb68b 2019-05-09 stsp local testroot=`test_init commit_single_file`
112 5bbcb68b 2019-05-09 stsp
113 5bbcb68b 2019-05-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
114 5bbcb68b 2019-05-09 stsp ret="$?"
115 5bbcb68b 2019-05-09 stsp if [ "$ret" != "0" ]; then
116 5bbcb68b 2019-05-09 stsp test_done "$testroot" "$ret"
117 5bbcb68b 2019-05-09 stsp return 1
118 5bbcb68b 2019-05-09 stsp fi
119 5bbcb68b 2019-05-09 stsp
120 5bbcb68b 2019-05-09 stsp echo "modified alpha" > $testroot/wt/alpha
121 5bbcb68b 2019-05-09 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
122 5bbcb68b 2019-05-09 stsp
123 1a36436d 2019-06-10 stsp (cd $testroot/wt && got commit -m 'changed zeta' epsilon/zeta \
124 5bbcb68b 2019-05-09 stsp > $testroot/stdout)
125 5bbcb68b 2019-05-09 stsp
126 5bbcb68b 2019-05-09 stsp local head_rev=`git_show_head $testroot/repo`
127 5bbcb68b 2019-05-09 stsp echo "M epsilon/zeta" >> $testroot/stdout.expected
128 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
129 5bbcb68b 2019-05-09 stsp
130 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
131 5bbcb68b 2019-05-09 stsp ret="$?"
132 5bbcb68b 2019-05-09 stsp if [ "$ret" != "0" ]; then
133 5bbcb68b 2019-05-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
134 5bbcb68b 2019-05-09 stsp fi
135 5bbcb68b 2019-05-09 stsp test_done "$testroot" "$ret"
136 5bbcb68b 2019-05-09 stsp }
137 5bbcb68b 2019-05-09 stsp
138 f6cae3ed 2020-09-13 naddy test_commit_out_of_date() {
139 819f385b 2019-05-10 stsp local testroot=`test_init commit_out_of_date`
140 f0b75401 2019-08-03 stsp local first_commit=`git_show_head $testroot/repo`
141 819f385b 2019-05-10 stsp
142 819f385b 2019-05-10 stsp got checkout $testroot/repo $testroot/wt > /dev/null
143 819f385b 2019-05-10 stsp ret="$?"
144 819f385b 2019-05-10 stsp if [ "$ret" != "0" ]; then
145 819f385b 2019-05-10 stsp test_done "$testroot" "$ret"
146 819f385b 2019-05-10 stsp return 1
147 819f385b 2019-05-10 stsp fi
148 819f385b 2019-05-10 stsp
149 819f385b 2019-05-10 stsp echo "modified alpha" > $testroot/repo/alpha
150 819f385b 2019-05-10 stsp git_commit $testroot/repo -m "modified alpha"
151 819f385b 2019-05-10 stsp
152 819f385b 2019-05-10 stsp echo "modified alpha" > $testroot/wt/alpha
153 819f385b 2019-05-10 stsp
154 819f385b 2019-05-10 stsp (cd $testroot/wt && got commit -m 'test commit_out_of_date' \
155 819f385b 2019-05-10 stsp > $testroot/stdout 2> $testroot/stderr)
156 819f385b 2019-05-10 stsp
157 819f385b 2019-05-10 stsp echo -n > $testroot/stdout.expected
158 819f385b 2019-05-10 stsp echo "got: work tree must be updated before these" \
159 819f385b 2019-05-10 stsp "changes can be committed" > $testroot/stderr.expected
160 819f385b 2019-05-10 stsp
161 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
162 819f385b 2019-05-10 stsp ret="$?"
163 819f385b 2019-05-10 stsp if [ "$ret" != "0" ]; then
164 819f385b 2019-05-10 stsp diff -u $testroot/stdout.expected $testroot/stdout
165 819f385b 2019-05-10 stsp test_done "$testroot" "$ret"
166 819f385b 2019-05-10 stsp return 1
167 819f385b 2019-05-10 stsp fi
168 819f385b 2019-05-10 stsp
169 8d301dd9 2019-05-14 stsp cmp -s $testroot/stderr.expected $testroot/stderr
170 819f385b 2019-05-10 stsp ret="$?"
171 819f385b 2019-05-10 stsp if [ "$ret" != "0" ]; then
172 819f385b 2019-05-10 stsp diff -u $testroot/stderr.expected $testroot/stderr
173 f0b75401 2019-08-03 stsp test_done "$testroot" "$ret"
174 f0b75401 2019-08-03 stsp return 1
175 819f385b 2019-05-10 stsp fi
176 f0b75401 2019-08-03 stsp
177 f0b75401 2019-08-03 stsp echo "alpha" > $testroot/repo/alpha
178 f0b75401 2019-08-03 stsp git_commit $testroot/repo -m "reset alpha contents"
179 f0b75401 2019-08-03 stsp (cd $testroot/wt && got update -c $first_commit > /dev/null)
180 f0b75401 2019-08-03 stsp
181 f0b75401 2019-08-03 stsp echo "modified alpha" > $testroot/wt/alpha
182 f0b75401 2019-08-03 stsp
183 f0b75401 2019-08-03 stsp (cd $testroot/wt && got commit -m 'changed alpha ' > $testroot/stdout)
184 f0b75401 2019-08-03 stsp ret="$?"
185 f0b75401 2019-08-03 stsp if [ "$ret" != "0" ]; then
186 f0b75401 2019-08-03 stsp echo "commit failed unexpectedly" >&2
187 f0b75401 2019-08-03 stsp test_done "$testroot" "1"
188 f0b75401 2019-08-03 stsp return 1
189 f0b75401 2019-08-03 stsp fi
190 f0b75401 2019-08-03 stsp
191 f0b75401 2019-08-03 stsp local head_rev=`git_show_head $testroot/repo`
192 f0b75401 2019-08-03 stsp echo "M alpha" > $testroot/stdout.expected
193 f0b75401 2019-08-03 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
194 f0b75401 2019-08-03 stsp cmp -s $testroot/stdout.expected $testroot/stdout
195 f0b75401 2019-08-03 stsp ret="$?"
196 f0b75401 2019-08-03 stsp if [ "$ret" != "0" ]; then
197 f0b75401 2019-08-03 stsp diff -u $testroot/stdout.expected $testroot/stdout
198 f0b75401 2019-08-03 stsp fi
199 819f385b 2019-05-10 stsp test_done "$testroot" "$ret"
200 819f385b 2019-05-10 stsp }
201 819f385b 2019-05-10 stsp
202 f6cae3ed 2020-09-13 naddy test_commit_added_subdirs() {
203 8ba6ba2d 2019-05-14 stsp local testroot=`test_init commit_added_subdirs`
204 8ba6ba2d 2019-05-14 stsp
205 8ba6ba2d 2019-05-14 stsp got checkout $testroot/repo $testroot/wt > /dev/null
206 8ba6ba2d 2019-05-14 stsp ret="$?"
207 8ba6ba2d 2019-05-14 stsp if [ "$ret" != "0" ]; then
208 8ba6ba2d 2019-05-14 stsp test_done "$testroot" "$ret"
209 8ba6ba2d 2019-05-14 stsp return 1
210 8ba6ba2d 2019-05-14 stsp fi
211 8ba6ba2d 2019-05-14 stsp
212 8ba6ba2d 2019-05-14 stsp mkdir -p $testroot/wt/d
213 8ba6ba2d 2019-05-14 stsp echo "new file" > $testroot/wt/d/new
214 8ba6ba2d 2019-05-14 stsp echo "new file 2" > $testroot/wt/d/new2
215 8ba6ba2d 2019-05-14 stsp mkdir -p $testroot/wt/d/f
216 8ba6ba2d 2019-05-14 stsp echo "new file 3" > $testroot/wt/d/f/new3
217 8ba6ba2d 2019-05-14 stsp mkdir -p $testroot/wt/d/f/g
218 8ba6ba2d 2019-05-14 stsp echo "new file 4" > $testroot/wt/d/f/g/new4
219 8ba6ba2d 2019-05-14 stsp
220 8ba6ba2d 2019-05-14 stsp (cd $testroot/wt && got add $testroot/wt/*/new* \
221 8ba6ba2d 2019-05-14 stsp $testroot/wt/*/*/new* $testroot/wt/*/*/*/new* > /dev/null)
222 8ba6ba2d 2019-05-14 stsp
223 8ba6ba2d 2019-05-14 stsp (cd $testroot/wt && got commit -m 'test commit_added_subdirs' \
224 8ba6ba2d 2019-05-14 stsp > $testroot/stdout 2> $testroot/stderr)
225 8ba6ba2d 2019-05-14 stsp
226 8ba6ba2d 2019-05-14 stsp local head_rev=`git_show_head $testroot/repo`
227 a3df2849 2019-05-20 stsp echo "A d/f/g/new4" > $testroot/stdout.expected
228 a3df2849 2019-05-20 stsp echo "A d/f/new3" >> $testroot/stdout.expected
229 8ba6ba2d 2019-05-14 stsp echo "A d/new" >> $testroot/stdout.expected
230 8ba6ba2d 2019-05-14 stsp echo "A d/new2" >> $testroot/stdout.expected
231 ba580f68 2020-03-22 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
232 ba580f68 2020-03-22 stsp
233 ba580f68 2020-03-22 stsp cmp -s $testroot/stdout.expected $testroot/stdout
234 ba580f68 2020-03-22 stsp ret="$?"
235 ba580f68 2020-03-22 stsp if [ "$ret" != "0" ]; then
236 ba580f68 2020-03-22 stsp diff -u $testroot/stdout.expected $testroot/stdout
237 ba580f68 2020-03-22 stsp fi
238 ba580f68 2020-03-22 stsp test_done "$testroot" "$ret"
239 ba580f68 2020-03-22 stsp }
240 ba580f68 2020-03-22 stsp
241 f6cae3ed 2020-09-13 naddy test_commit_deleted_subdirs() {
242 ba580f68 2020-03-22 stsp local testroot=`test_init commit_deleted_subdirs`
243 ba580f68 2020-03-22 stsp
244 ba580f68 2020-03-22 stsp got checkout $testroot/repo $testroot/wt > /dev/null
245 ba580f68 2020-03-22 stsp ret="$?"
246 ba580f68 2020-03-22 stsp if [ "$ret" != "0" ]; then
247 ba580f68 2020-03-22 stsp test_done "$testroot" "$ret"
248 ba580f68 2020-03-22 stsp return 1
249 ba580f68 2020-03-22 stsp fi
250 ba580f68 2020-03-22 stsp
251 c8c7d149 2020-09-17 naddy (cd $testroot/wt && \
252 c8c7d149 2020-09-17 naddy got rm -R $testroot/wt/epsilon $testroot/wt/gamma >/dev/null)
253 ba580f68 2020-03-22 stsp
254 ba580f68 2020-03-22 stsp (cd $testroot/wt && got commit -m 'test commit_deleted_subdirs' \
255 ba580f68 2020-03-22 stsp > $testroot/stdout 2> $testroot/stderr)
256 ba580f68 2020-03-22 stsp
257 ba580f68 2020-03-22 stsp local head_rev=`git_show_head $testroot/repo`
258 ba580f68 2020-03-22 stsp echo "D epsilon/zeta" > $testroot/stdout.expected
259 ba580f68 2020-03-22 stsp echo "D gamma/delta" >> $testroot/stdout.expected
260 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
261 ba580f68 2020-03-22 stsp
262 ba580f68 2020-03-22 stsp cmp -s $testroot/stdout.expected $testroot/stdout
263 ba580f68 2020-03-22 stsp ret="$?"
264 ba580f68 2020-03-22 stsp if [ "$ret" != "0" ]; then
265 ba580f68 2020-03-22 stsp diff -u $testroot/stdout.expected $testroot/stdout
266 ba580f68 2020-03-22 stsp test_done "$testroot" "$ret"
267 ba580f68 2020-03-22 stsp return 1
268 ba580f68 2020-03-22 stsp fi
269 8ba6ba2d 2019-05-14 stsp
270 ba580f68 2020-03-22 stsp got tree -r $testroot/repo > $testroot/stdout
271 ba580f68 2020-03-22 stsp
272 ba580f68 2020-03-22 stsp echo "alpha" > $testroot/stdout.expected
273 ba580f68 2020-03-22 stsp echo "beta" >> $testroot/stdout.expected
274 ba580f68 2020-03-22 stsp
275 8ba6ba2d 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
276 8ba6ba2d 2019-05-14 stsp ret="$?"
277 8ba6ba2d 2019-05-14 stsp if [ "$ret" != "0" ]; then
278 a3df2849 2019-05-20 stsp diff -u $testroot/stdout.expected $testroot/stdout
279 8ba6ba2d 2019-05-14 stsp fi
280 8ba6ba2d 2019-05-14 stsp test_done "$testroot" "$ret"
281 8ba6ba2d 2019-05-14 stsp }
282 8ba6ba2d 2019-05-14 stsp
283 f6cae3ed 2020-09-13 naddy test_commit_rejects_conflicted_file() {
284 461aee03 2019-06-29 stsp local testroot=`test_init commit_rejects_conflicted_file`
285 f363d663 2019-05-23 stsp
286 f363d663 2019-05-23 stsp local initial_rev=`git_show_head $testroot/repo`
287 f363d663 2019-05-23 stsp
288 f363d663 2019-05-23 stsp got checkout $testroot/repo $testroot/wt > /dev/null
289 f363d663 2019-05-23 stsp ret="$?"
290 f363d663 2019-05-23 stsp if [ "$ret" != "0" ]; then
291 f363d663 2019-05-23 stsp test_done "$testroot" "$ret"
292 f363d663 2019-05-23 stsp return 1
293 f363d663 2019-05-23 stsp fi
294 f363d663 2019-05-23 stsp
295 f363d663 2019-05-23 stsp echo "modified alpha" > $testroot/wt/alpha
296 f363d663 2019-05-23 stsp (cd $testroot/wt && got commit -m "modified alpha" >/dev/null)
297 f363d663 2019-05-23 stsp
298 f363d663 2019-05-23 stsp (cd $testroot/wt && got update -c $initial_rev > /dev/null)
299 f363d663 2019-05-23 stsp
300 f363d663 2019-05-23 stsp echo "modified alpha, too" > $testroot/wt/alpha
301 f363d663 2019-05-23 stsp
302 f363d663 2019-05-23 stsp echo "C alpha" > $testroot/stdout.expected
303 4f3c844b 2021-09-14 stsp echo -n "Updated to refs/heads/master: " >> $testroot/stdout.expected
304 f363d663 2019-05-23 stsp git_show_head $testroot/repo >> $testroot/stdout.expected
305 f363d663 2019-05-23 stsp echo >> $testroot/stdout.expected
306 9627c110 2020-04-18 stsp echo "Files with new merge conflicts: 1" >> $testroot/stdout.expected
307 f363d663 2019-05-23 stsp
308 f363d663 2019-05-23 stsp (cd $testroot/wt && got update > $testroot/stdout)
309 f363d663 2019-05-23 stsp
310 f363d663 2019-05-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
311 f363d663 2019-05-23 stsp ret="$?"
312 f363d663 2019-05-23 stsp if [ "$ret" != "0" ]; then
313 f363d663 2019-05-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
314 f363d663 2019-05-23 stsp test_done "$testroot" "$ret"
315 f363d663 2019-05-23 stsp return 1
316 f363d663 2019-05-23 stsp fi
317 f363d663 2019-05-23 stsp
318 f363d663 2019-05-23 stsp (cd $testroot/wt && got commit -m 'commit it' > $testroot/stdout \
319 f363d663 2019-05-23 stsp 2> $testroot/stderr)
320 f363d663 2019-05-23 stsp
321 f363d663 2019-05-23 stsp echo -n > $testroot/stdout.expected
322 f363d663 2019-05-23 stsp echo "got: cannot commit file in conflicted status" \
323 f363d663 2019-05-23 stsp > $testroot/stderr.expected
324 f363d663 2019-05-23 stsp
325 f363d663 2019-05-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
326 f363d663 2019-05-23 stsp ret="$?"
327 f363d663 2019-05-23 stsp if [ "$ret" != "0" ]; then
328 f363d663 2019-05-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
329 f363d663 2019-05-23 stsp test_done "$testroot" "$ret"
330 f363d663 2019-05-23 stsp return 1
331 f363d663 2019-05-23 stsp fi
332 f363d663 2019-05-23 stsp cmp -s $testroot/stderr.expected $testroot/stderr
333 f363d663 2019-05-23 stsp ret="$?"
334 f363d663 2019-05-23 stsp if [ "$ret" != "0" ]; then
335 f363d663 2019-05-23 stsp diff -u $testroot/stderr.expected $testroot/stderr
336 f363d663 2019-05-23 stsp fi
337 f363d663 2019-05-23 stsp test_done "$testroot" "$ret"
338 f363d663 2019-05-23 stsp }
339 1a36436d 2019-06-10 stsp
340 f6cae3ed 2020-09-13 naddy test_commit_single_file_multiple() {
341 1a36436d 2019-06-10 stsp local testroot=`test_init commit_single_file_multiple`
342 f363d663 2019-05-23 stsp
343 1a36436d 2019-06-10 stsp got checkout $testroot/repo $testroot/wt > /dev/null
344 1a36436d 2019-06-10 stsp ret="$?"
345 1a36436d 2019-06-10 stsp if [ "$ret" != "0" ]; then
346 1a36436d 2019-06-10 stsp test_done "$testroot" "$ret"
347 1a36436d 2019-06-10 stsp return 1
348 1a36436d 2019-06-10 stsp fi
349 1a36436d 2019-06-10 stsp
350 1a36436d 2019-06-10 stsp for i in 1 2 3 4; do
351 1a36436d 2019-06-10 stsp echo "modified alpha" >> $testroot/wt/alpha
352 1a36436d 2019-06-10 stsp
353 1a36436d 2019-06-10 stsp (cd $testroot/wt && \
354 1a36436d 2019-06-10 stsp got commit -m "changed alpha" > $testroot/stdout)
355 1a36436d 2019-06-10 stsp
356 1a36436d 2019-06-10 stsp local head_rev=`git_show_head $testroot/repo`
357 1a36436d 2019-06-10 stsp echo "M alpha" > $testroot/stdout.expected
358 1a36436d 2019-06-10 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
359 1a36436d 2019-06-10 stsp
360 1a36436d 2019-06-10 stsp cmp -s $testroot/stdout.expected $testroot/stdout
361 1a36436d 2019-06-10 stsp ret="$?"
362 1a36436d 2019-06-10 stsp if [ "$ret" != "0" ]; then
363 1a36436d 2019-06-10 stsp diff -u $testroot/stdout.expected $testroot/stdout
364 1a36436d 2019-06-10 stsp test_done "$testroot" "$ret"
365 1a36436d 2019-06-10 stsp return 1
366 1a36436d 2019-06-10 stsp fi
367 1a36436d 2019-06-10 stsp done
368 1a36436d 2019-06-10 stsp
369 1a36436d 2019-06-10 stsp test_done "$testroot" "0"
370 1a36436d 2019-06-10 stsp }
371 4866d084 2019-07-10 stsp
372 f6cae3ed 2020-09-13 naddy test_commit_added_and_modified_in_same_dir() {
373 4866d084 2019-07-10 stsp local testroot=`test_init commit_added_and_modified_in_same_dir`
374 1a36436d 2019-06-10 stsp
375 4866d084 2019-07-10 stsp got checkout $testroot/repo $testroot/wt > /dev/null
376 4866d084 2019-07-10 stsp ret="$?"
377 4866d084 2019-07-10 stsp if [ "$ret" != "0" ]; then
378 4866d084 2019-07-10 stsp test_done "$testroot" "$ret"
379 4866d084 2019-07-10 stsp return 1
380 4866d084 2019-07-10 stsp fi
381 4866d084 2019-07-10 stsp
382 4866d084 2019-07-10 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
383 4866d084 2019-07-10 stsp echo "new file" > $testroot/wt/epsilon/new
384 4866d084 2019-07-10 stsp (cd $testroot/wt && got add epsilon/new >/dev/null)
385 4866d084 2019-07-10 stsp
386 4866d084 2019-07-10 stsp (cd $testroot/wt && got commit \
387 4866d084 2019-07-10 stsp -m 'added and modified in same dir' > $testroot/stdout \
388 4866d084 2019-07-10 stsp 2> $testroot/stderr)
389 4866d084 2019-07-10 stsp
390 4866d084 2019-07-10 stsp local head_rev=`git_show_head $testroot/repo`
391 4866d084 2019-07-10 stsp echo "A epsilon/new" > $testroot/stdout.expected
392 4866d084 2019-07-10 stsp echo "M epsilon/zeta" >> $testroot/stdout.expected
393 4866d084 2019-07-10 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
394 e0233cea 2019-07-25 stsp
395 e0233cea 2019-07-25 stsp cmp -s $testroot/stdout.expected $testroot/stdout
396 e0233cea 2019-07-25 stsp ret="$?"
397 e0233cea 2019-07-25 stsp if [ "$ret" != "0" ]; then
398 e0233cea 2019-07-25 stsp diff -u $testroot/stdout.expected $testroot/stdout
399 e0233cea 2019-07-25 stsp fi
400 e0233cea 2019-07-25 stsp test_done "$testroot" "$ret"
401 e0233cea 2019-07-25 stsp }
402 e0233cea 2019-07-25 stsp
403 f6cae3ed 2020-09-13 naddy test_commit_path_prefix() {
404 e0233cea 2019-07-25 stsp local testroot=`test_init commit_path_prefix`
405 e0233cea 2019-07-25 stsp local commit1=`git_show_head $testroot/repo`
406 e0233cea 2019-07-25 stsp
407 e0233cea 2019-07-25 stsp got checkout -p gamma $testroot/repo $testroot/wt > /dev/null
408 e0233cea 2019-07-25 stsp ret="$?"
409 e0233cea 2019-07-25 stsp if [ "$ret" != "0" ]; then
410 e0233cea 2019-07-25 stsp test_done "$testroot" "$ret"
411 e0233cea 2019-07-25 stsp return 1
412 e0233cea 2019-07-25 stsp fi
413 e0233cea 2019-07-25 stsp
414 e0233cea 2019-07-25 stsp echo "modified delta" > $testroot/wt/delta
415 e0233cea 2019-07-25 stsp
416 e0233cea 2019-07-25 stsp (cd $testroot/wt && got commit -m 'changed gamma/delta' > $testroot/stdout)
417 e0233cea 2019-07-25 stsp
418 e0233cea 2019-07-25 stsp local commit2=`git_show_head $testroot/repo`
419 e0233cea 2019-07-25 stsp echo "M delta" > $testroot/stdout.expected
420 e0233cea 2019-07-25 stsp echo "Created commit $commit2" >> $testroot/stdout.expected
421 4866d084 2019-07-10 stsp
422 4866d084 2019-07-10 stsp cmp -s $testroot/stdout.expected $testroot/stdout
423 4866d084 2019-07-10 stsp ret="$?"
424 4866d084 2019-07-10 stsp if [ "$ret" != "0" ]; then
425 2b496619 2019-07-10 stsp diff -u $testroot/stdout.expected $testroot/stdout
426 e0233cea 2019-07-25 stsp test_done "$testroot" "$ret"
427 e0233cea 2019-07-25 stsp return 1
428 4866d084 2019-07-10 stsp fi
429 e0233cea 2019-07-25 stsp
430 e0233cea 2019-07-25 stsp echo "diff $commit1 $commit2" > $testroot/stdout.expected
431 e0233cea 2019-07-25 stsp echo -n 'blob - ' >> $testroot/stdout.expected
432 e0233cea 2019-07-25 stsp got tree -r $testroot/repo -c $commit1 -i gamma | grep 'delta$' \
433 e0233cea 2019-07-25 stsp | cut -d' ' -f 1 >> $testroot/stdout.expected
434 e0233cea 2019-07-25 stsp echo -n 'blob + ' >> $testroot/stdout.expected
435 e0233cea 2019-07-25 stsp got tree -r $testroot/repo -c $commit2 -i gamma | grep 'delta$' | \
436 e0233cea 2019-07-25 stsp cut -d' ' -f 1 >> $testroot/stdout.expected
437 e0233cea 2019-07-25 stsp echo '--- gamma/delta' >> $testroot/stdout.expected
438 e0233cea 2019-07-25 stsp echo '+++ gamma/delta' >> $testroot/stdout.expected
439 e0233cea 2019-07-25 stsp echo '@@ -1 +1 @@' >> $testroot/stdout.expected
440 e0233cea 2019-07-25 stsp echo '-delta' >> $testroot/stdout.expected
441 e0233cea 2019-07-25 stsp echo '+modified delta' >> $testroot/stdout.expected
442 e0233cea 2019-07-25 stsp
443 e0233cea 2019-07-25 stsp got diff -r $testroot/repo $commit1 $commit2 > $testroot/stdout
444 f2b0a8b0 2020-07-31 stsp cmp -s $testroot/stdout.expected $testroot/stdout
445 f2b0a8b0 2020-07-31 stsp ret="$?"
446 f2b0a8b0 2020-07-31 stsp if [ "$ret" != "0" ]; then
447 f2b0a8b0 2020-07-31 stsp diff -u $testroot/stdout.expected $testroot/stdout
448 f2b0a8b0 2020-07-31 stsp test_done "$testroot" "$ret"
449 f2b0a8b0 2020-07-31 stsp return 1
450 f2b0a8b0 2020-07-31 stsp fi
451 f2b0a8b0 2020-07-31 stsp
452 f2b0a8b0 2020-07-31 stsp (cd $testroot/wt && got rm delta > /dev/null)
453 f2b0a8b0 2020-07-31 stsp echo new > $testroot/wt/new
454 f2b0a8b0 2020-07-31 stsp (cd $testroot/wt && got add new > /dev/null)
455 f2b0a8b0 2020-07-31 stsp
456 f2b0a8b0 2020-07-31 stsp (cd $testroot/wt && got commit -m 'remove gamma/delta; add gamma/new' \
457 f2b0a8b0 2020-07-31 stsp > $testroot/stdout)
458 f2b0a8b0 2020-07-31 stsp
459 f2b0a8b0 2020-07-31 stsp local commit3=`git_show_head $testroot/repo`
460 f2b0a8b0 2020-07-31 stsp echo "A new" > $testroot/stdout.expected
461 f2b0a8b0 2020-07-31 stsp echo "D delta" >> $testroot/stdout.expected
462 f2b0a8b0 2020-07-31 stsp echo "Created commit $commit3" >> $testroot/stdout.expected
463 f2b0a8b0 2020-07-31 stsp
464 f2b0a8b0 2020-07-31 stsp cmp -s $testroot/stdout.expected $testroot/stdout
465 f2b0a8b0 2020-07-31 stsp ret="$?"
466 f2b0a8b0 2020-07-31 stsp if [ "$ret" != "0" ]; then
467 f2b0a8b0 2020-07-31 stsp diff -u $testroot/stdout.expected $testroot/stdout
468 f2b0a8b0 2020-07-31 stsp test_done "$testroot" "$ret"
469 f2b0a8b0 2020-07-31 stsp return 1
470 f2b0a8b0 2020-07-31 stsp fi
471 f2b0a8b0 2020-07-31 stsp
472 f2b0a8b0 2020-07-31 stsp echo "diff $commit2 $commit3" > $testroot/stdout.expected
473 f2b0a8b0 2020-07-31 stsp echo -n 'blob - ' >> $testroot/stdout.expected
474 f2b0a8b0 2020-07-31 stsp got tree -r $testroot/repo -c $commit2 -i gamma | grep 'delta$' \
475 f2b0a8b0 2020-07-31 stsp | cut -d' ' -f 1 | sed -e 's/$/ (mode 644)/' \
476 f2b0a8b0 2020-07-31 stsp >> $testroot/stdout.expected
477 f2b0a8b0 2020-07-31 stsp echo 'blob + /dev/null' >> $testroot/stdout.expected
478 f2b0a8b0 2020-07-31 stsp echo '--- gamma/delta' >> $testroot/stdout.expected
479 f2b0a8b0 2020-07-31 stsp echo '+++ /dev/null' >> $testroot/stdout.expected
480 f2b0a8b0 2020-07-31 stsp echo '@@ -1 +0,0 @@' >> $testroot/stdout.expected
481 f2b0a8b0 2020-07-31 stsp echo '-modified delta' >> $testroot/stdout.expected
482 f2b0a8b0 2020-07-31 stsp echo 'blob - /dev/null' >> $testroot/stdout.expected
483 f2b0a8b0 2020-07-31 stsp echo -n 'blob + ' >> $testroot/stdout.expected
484 f2b0a8b0 2020-07-31 stsp got tree -r $testroot/repo -c $commit3 -i gamma | grep 'new$' | \
485 f2b0a8b0 2020-07-31 stsp cut -d' ' -f 1 | sed -e 's/$/ (mode 644)/' \
486 f2b0a8b0 2020-07-31 stsp >> $testroot/stdout.expected
487 f2b0a8b0 2020-07-31 stsp echo '--- /dev/null' >> $testroot/stdout.expected
488 f2b0a8b0 2020-07-31 stsp echo '+++ gamma/new' >> $testroot/stdout.expected
489 f2b0a8b0 2020-07-31 stsp echo '@@ -0,0 +1 @@' >> $testroot/stdout.expected
490 f2b0a8b0 2020-07-31 stsp echo '+new' >> $testroot/stdout.expected
491 f2b0a8b0 2020-07-31 stsp
492 f2b0a8b0 2020-07-31 stsp got diff -r $testroot/repo $commit2 $commit3 > $testroot/stdout
493 e0233cea 2019-07-25 stsp cmp -s $testroot/stdout.expected $testroot/stdout
494 e0233cea 2019-07-25 stsp ret="$?"
495 e0233cea 2019-07-25 stsp if [ "$ret" != "0" ]; then
496 e0233cea 2019-07-25 stsp diff -u $testroot/stdout.expected $testroot/stdout
497 e0233cea 2019-07-25 stsp fi
498 4866d084 2019-07-10 stsp test_done "$testroot" "$ret"
499 f2b0a8b0 2020-07-31 stsp return "$ret"
500 4866d084 2019-07-10 stsp }
501 90e8619e 2019-07-25 stsp
502 f6cae3ed 2020-09-13 naddy test_commit_dir_path() {
503 90e8619e 2019-07-25 stsp local testroot=`test_init commit_dir_path`
504 4866d084 2019-07-10 stsp
505 90e8619e 2019-07-25 stsp got checkout $testroot/repo $testroot/wt > /dev/null
506 90e8619e 2019-07-25 stsp ret="$?"
507 90e8619e 2019-07-25 stsp if [ "$ret" != "0" ]; then
508 90e8619e 2019-07-25 stsp test_done "$testroot" "$ret"
509 90e8619e 2019-07-25 stsp return 1
510 90e8619e 2019-07-25 stsp fi
511 90e8619e 2019-07-25 stsp
512 90e8619e 2019-07-25 stsp echo "modified alpha" > $testroot/wt/alpha
513 90e8619e 2019-07-25 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
514 90e8619e 2019-07-25 stsp
515 90e8619e 2019-07-25 stsp (cd $testroot/wt && got commit -m 'changed zeta' epsilon \
516 90e8619e 2019-07-25 stsp > $testroot/stdout)
517 90e8619e 2019-07-25 stsp
518 90e8619e 2019-07-25 stsp local head_rev=`git_show_head $testroot/repo`
519 90e8619e 2019-07-25 stsp echo "M epsilon/zeta" >> $testroot/stdout.expected
520 90e8619e 2019-07-25 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
521 90e8619e 2019-07-25 stsp
522 90e8619e 2019-07-25 stsp cmp -s $testroot/stdout.expected $testroot/stdout
523 90e8619e 2019-07-25 stsp ret="$?"
524 90e8619e 2019-07-25 stsp if [ "$ret" != "0" ]; then
525 90e8619e 2019-07-25 stsp diff -u $testroot/stdout.expected $testroot/stdout
526 90e8619e 2019-07-25 stsp test_done "$testroot" "$ret"
527 90e8619e 2019-07-25 stsp return 1
528 90e8619e 2019-07-25 stsp fi
529 90e8619e 2019-07-25 stsp
530 90e8619e 2019-07-25 stsp echo "M alpha" > $testroot/stdout.expected
531 90e8619e 2019-07-25 stsp (cd $testroot/wt && got status > $testroot/stdout)
532 90e8619e 2019-07-25 stsp cmp -s $testroot/stdout.expected $testroot/stdout
533 90e8619e 2019-07-25 stsp ret="$?"
534 90e8619e 2019-07-25 stsp if [ "$ret" != "0" ]; then
535 90e8619e 2019-07-25 stsp diff -u $testroot/stdout.expected $testroot/stdout
536 90e8619e 2019-07-25 stsp fi
537 90e8619e 2019-07-25 stsp test_done "$testroot" "$ret"
538 90e8619e 2019-07-25 stsp }
539 5c1e53bc 2019-07-28 stsp
540 f6cae3ed 2020-09-13 naddy test_commit_selected_paths() {
541 5c1e53bc 2019-07-28 stsp local testroot=`test_init commit_selected_paths`
542 5c1e53bc 2019-07-28 stsp
543 5c1e53bc 2019-07-28 stsp got checkout $testroot/repo $testroot/wt > /dev/null
544 5c1e53bc 2019-07-28 stsp ret="$?"
545 5c1e53bc 2019-07-28 stsp if [ "$ret" != "0" ]; then
546 5c1e53bc 2019-07-28 stsp test_done "$testroot" "$ret"
547 5c1e53bc 2019-07-28 stsp return 1
548 5c1e53bc 2019-07-28 stsp fi
549 5c1e53bc 2019-07-28 stsp
550 5c1e53bc 2019-07-28 stsp echo "modified alpha" > $testroot/wt/alpha
551 5c1e53bc 2019-07-28 stsp echo "modified delta" > $testroot/wt/gamma/delta
552 5c1e53bc 2019-07-28 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
553 5c1e53bc 2019-07-28 stsp (cd $testroot/wt && got rm beta >/dev/null)
554 5c1e53bc 2019-07-28 stsp echo "new file" > $testroot/wt/new
555 5c1e53bc 2019-07-28 stsp (cd $testroot/wt && got add new >/dev/null)
556 90e8619e 2019-07-25 stsp
557 5c1e53bc 2019-07-28 stsp (cd $testroot/wt && got commit -m 'many paths' nonexistent alpha \
558 5c1e53bc 2019-07-28 stsp > $testroot/stdout 2> $testroot/stderr)
559 5c1e53bc 2019-07-28 stsp ret="$?"
560 54c39596 2020-12-28 stsp if [ "$ret" = "0" ]; then
561 5c1e53bc 2019-07-28 stsp echo "commit succeeded unexpectedly" >&2
562 5c1e53bc 2019-07-28 stsp test_done "$testroot" "1"
563 5c1e53bc 2019-07-28 stsp return 1
564 5c1e53bc 2019-07-28 stsp fi
565 5c1e53bc 2019-07-28 stsp echo "got: nonexistent: bad path" > $testroot/stderr.expected
566 5c1e53bc 2019-07-28 stsp
567 5c1e53bc 2019-07-28 stsp cmp -s $testroot/stderr.expected $testroot/stderr
568 5c1e53bc 2019-07-28 stsp ret="$?"
569 5c1e53bc 2019-07-28 stsp if [ "$ret" != "0" ]; then
570 5c1e53bc 2019-07-28 stsp diff -u $testroot/stderr.expected $testroot/stderr
571 5c1e53bc 2019-07-28 stsp test_done "$testroot" "$ret"
572 5c1e53bc 2019-07-28 stsp return 1
573 5c1e53bc 2019-07-28 stsp fi
574 5c1e53bc 2019-07-28 stsp
575 5c1e53bc 2019-07-28 stsp (cd $testroot/wt && got commit -m 'many paths' \
576 5c1e53bc 2019-07-28 stsp beta new gamma > $testroot/stdout)
577 5c1e53bc 2019-07-28 stsp
578 5c1e53bc 2019-07-28 stsp local head_rev=`git_show_head $testroot/repo`
579 5c1e53bc 2019-07-28 stsp echo "A new" > $testroot/stdout.expected
580 5c1e53bc 2019-07-28 stsp echo "D beta" >> $testroot/stdout.expected
581 5c1e53bc 2019-07-28 stsp echo "M gamma/delta" >> $testroot/stdout.expected
582 5c1e53bc 2019-07-28 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
583 5c1e53bc 2019-07-28 stsp
584 5c1e53bc 2019-07-28 stsp cmp -s $testroot/stdout.expected $testroot/stdout
585 5c1e53bc 2019-07-28 stsp ret="$?"
586 5c1e53bc 2019-07-28 stsp if [ "$ret" != "0" ]; then
587 5c1e53bc 2019-07-28 stsp diff -u $testroot/stdout.expected $testroot/stdout
588 5c1e53bc 2019-07-28 stsp fi
589 5c1e53bc 2019-07-28 stsp test_done "$testroot" "$ret"
590 5c1e53bc 2019-07-28 stsp }
591 5c1e53bc 2019-07-28 stsp
592 f6cae3ed 2020-09-13 naddy test_commit_outside_refs_heads() {
593 916f288c 2019-07-30 stsp local testroot=`test_init commit_outside_refs_heads`
594 916f288c 2019-07-30 stsp
595 e31abbf2 2020-03-22 stsp got ref -r $testroot/repo -c master refs/remotes/origin/master
596 916f288c 2019-07-30 stsp
597 916f288c 2019-07-30 stsp got checkout -b refs/remotes/origin/master \
598 916f288c 2019-07-30 stsp $testroot/repo $testroot/wt > /dev/null
599 916f288c 2019-07-30 stsp ret="$?"
600 916f288c 2019-07-30 stsp if [ "$ret" != "0" ]; then
601 916f288c 2019-07-30 stsp test_done "$testroot" "$ret"
602 916f288c 2019-07-30 stsp return 1
603 916f288c 2019-07-30 stsp fi
604 916f288c 2019-07-30 stsp
605 916f288c 2019-07-30 stsp echo "modified alpha" > $testroot/wt/alpha
606 916f288c 2019-07-30 stsp
607 916f288c 2019-07-30 stsp (cd $testroot/wt && got commit -m 'change alpha' \
608 916f288c 2019-07-30 stsp > $testroot/stdout 2> $testroot/stderr)
609 916f288c 2019-07-30 stsp ret="$?"
610 54c39596 2020-12-28 stsp if [ "$ret" = "0" ]; then
611 916f288c 2019-07-30 stsp echo "commit succeeded unexpectedly" >&2
612 916f288c 2019-07-30 stsp test_done "$testroot" "1"
613 916f288c 2019-07-30 stsp return 1
614 916f288c 2019-07-30 stsp fi
615 916f288c 2019-07-30 stsp
616 916f288c 2019-07-30 stsp echo -n > $testroot/stdout.expected
617 916f288c 2019-07-30 stsp cmp -s $testroot/stdout.expected $testroot/stdout
618 916f288c 2019-07-30 stsp ret="$?"
619 916f288c 2019-07-30 stsp if [ "$ret" != "0" ]; then
620 916f288c 2019-07-30 stsp diff -u $testroot/stdout.expected $testroot/stdout
621 916f288c 2019-07-30 stsp test_done "$testroot" "$ret"
622 916f288c 2019-07-30 stsp return 1
623 916f288c 2019-07-30 stsp fi
624 916f288c 2019-07-30 stsp
625 916f288c 2019-07-30 stsp echo -n "got: will not commit to a branch outside the " \
626 916f288c 2019-07-30 stsp > $testroot/stderr.expected
627 916f288c 2019-07-30 stsp echo '"refs/heads/" reference namespace' \
628 916f288c 2019-07-30 stsp >> $testroot/stderr.expected
629 916f288c 2019-07-30 stsp cmp -s $testroot/stderr.expected $testroot/stderr
630 916f288c 2019-07-30 stsp ret="$?"
631 916f288c 2019-07-30 stsp if [ "$ret" != "0" ]; then
632 916f288c 2019-07-30 stsp diff -u $testroot/stderr.expected $testroot/stderr
633 916f288c 2019-07-30 stsp fi
634 916f288c 2019-07-30 stsp test_done "$testroot" "$ret"
635 916f288c 2019-07-30 stsp }
636 916f288c 2019-07-30 stsp
637 f6cae3ed 2020-09-13 naddy test_commit_no_email() {
638 84792843 2019-08-09 stsp local testroot=`test_init commit_no_email`
639 916f288c 2019-07-30 stsp
640 84792843 2019-08-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
641 84792843 2019-08-09 stsp ret="$?"
642 84792843 2019-08-09 stsp if [ "$ret" != "0" ]; then
643 84792843 2019-08-09 stsp test_done "$testroot" "$ret"
644 84792843 2019-08-09 stsp return 1
645 84792843 2019-08-09 stsp fi
646 84792843 2019-08-09 stsp
647 84792843 2019-08-09 stsp echo "modified alpha" > $testroot/wt/alpha
648 84792843 2019-08-09 stsp (cd $testroot/wt && env GOT_AUTHOR=":flan_hacker:" \
649 84792843 2019-08-09 stsp got commit -m 'test no email' > $testroot/stdout \
650 84792843 2019-08-09 stsp 2> $testroot/stderr)
651 84792843 2019-08-09 stsp
652 84792843 2019-08-09 stsp echo -n "got: GOT_AUTHOR environment variable contains no email " \
653 84792843 2019-08-09 stsp > $testroot/stderr.expected
654 84792843 2019-08-09 stsp echo -n "address; an email address is required for compatibility "\
655 84792843 2019-08-09 stsp >> $testroot/stderr.expected
656 84792843 2019-08-09 stsp echo "with Git" >> $testroot/stderr.expected
657 84792843 2019-08-09 stsp cmp -s $testroot/stderr.expected $testroot/stderr
658 84792843 2019-08-09 stsp ret="$?"
659 84792843 2019-08-09 stsp if [ "$ret" != "0" ]; then
660 84792843 2019-08-09 stsp diff -u $testroot/stderr.expected $testroot/stderr
661 84792843 2019-08-09 stsp test_done "$testroot" "$ret"
662 84792843 2019-08-09 stsp return 1
663 84792843 2019-08-09 stsp fi
664 84792843 2019-08-09 stsp
665 84792843 2019-08-09 stsp echo -n > $testroot/stdout.expected
666 84792843 2019-08-09 stsp cmp -s $testroot/stdout.expected $testroot/stdout
667 84792843 2019-08-09 stsp ret="$?"
668 84792843 2019-08-09 stsp if [ "$ret" != "0" ]; then
669 84792843 2019-08-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
670 84792843 2019-08-09 stsp fi
671 84792843 2019-08-09 stsp test_done "$testroot" "$ret"
672 84792843 2019-08-09 stsp }
673 6af1ccbd 2019-08-16 stsp
674 f6cae3ed 2020-09-13 naddy test_commit_tree_entry_sorting() {
675 6af1ccbd 2019-08-16 stsp local testroot=`test_init commit_tree_entry_sorting`
676 6af1ccbd 2019-08-16 stsp
677 6af1ccbd 2019-08-16 stsp got checkout $testroot/repo $testroot/wt > /dev/null
678 6af1ccbd 2019-08-16 stsp ret="$?"
679 6af1ccbd 2019-08-16 stsp if [ "$ret" != "0" ]; then
680 6af1ccbd 2019-08-16 stsp test_done "$testroot" "$ret"
681 6af1ccbd 2019-08-16 stsp return 1
682 6af1ccbd 2019-08-16 stsp fi
683 6af1ccbd 2019-08-16 stsp
684 6af1ccbd 2019-08-16 stsp # Git's index gets corrupted when tree entries are written in the
685 6af1ccbd 2019-08-16 stsp # order defined by got_path_cmp() rather than Git's own ordering.
686 6af1ccbd 2019-08-16 stsp # Create a new tree where a directory "got" and a file "got-version"
687 6af1ccbd 2019-08-16 stsp # would sort in the wrong order according to Git's opinion.
688 6af1ccbd 2019-08-16 stsp mkdir $testroot/wt/got
689 6af1ccbd 2019-08-16 stsp touch $testroot/wt/got/foo
690 6af1ccbd 2019-08-16 stsp echo foo > $testroot/wt/got-version
691 6af1ccbd 2019-08-16 stsp echo zzz > $testroot/wt/zzz
692 6af1ccbd 2019-08-16 stsp (cd $testroot/wt && got add got-version got/foo zzz > /dev/null)
693 84792843 2019-08-09 stsp
694 6af1ccbd 2019-08-16 stsp (cd $testroot/wt && got commit -m 'test' > /dev/null)
695 84792843 2019-08-09 stsp
696 6af1ccbd 2019-08-16 stsp # Let git-fsck verify the newly written tree to make sure Git is happy
697 6af1ccbd 2019-08-16 stsp (cd $testroot/repo && git fsck --strict \
698 6af1ccbd 2019-08-16 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
699 257add31 2020-09-09 stsp ret="$?"
700 257add31 2020-09-09 stsp test_done "$testroot" "$ret"
701 257add31 2020-09-09 stsp }
702 257add31 2020-09-09 stsp
703 f6cae3ed 2020-09-13 naddy test_commit_gotconfig_author() {
704 257add31 2020-09-09 stsp local testroot=`test_init commit_gotconfig_author`
705 257add31 2020-09-09 stsp
706 257add31 2020-09-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
707 257add31 2020-09-09 stsp ret="$?"
708 257add31 2020-09-09 stsp if [ "$ret" != "0" ]; then
709 257add31 2020-09-09 stsp test_done "$testroot" "$ret"
710 257add31 2020-09-09 stsp return 1
711 257add31 2020-09-09 stsp fi
712 257add31 2020-09-09 stsp echo 'author "Flan Luck <flan_luck@openbsd.org>"' \
713 257add31 2020-09-09 stsp > $testroot/repo/.git/got.conf
714 257add31 2020-09-09 stsp
715 257add31 2020-09-09 stsp echo "modified alpha" > $testroot/wt/alpha
716 257add31 2020-09-09 stsp (cd $testroot/wt && got commit -m 'test gotconfig author' > /dev/null)
717 257add31 2020-09-09 stsp ret="$?"
718 257add31 2020-09-09 stsp if [ "$ret" != "0" ]; then
719 257add31 2020-09-09 stsp test_done "$testroot" "$ret"
720 257add31 2020-09-09 stsp return 1
721 257add31 2020-09-09 stsp fi
722 257add31 2020-09-09 stsp
723 257add31 2020-09-09 stsp (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
724 257add31 2020-09-09 stsp ret="$?"
725 257add31 2020-09-09 stsp if [ "$ret" != "0" ]; then
726 257add31 2020-09-09 stsp test_done "$testroot" "$ret"
727 257add31 2020-09-09 stsp return 1
728 257add31 2020-09-09 stsp fi
729 257add31 2020-09-09 stsp
730 257add31 2020-09-09 stsp echo "from: Flan Luck <flan_luck@openbsd.org>" \
731 50b0790e 2020-09-11 stsp > $testroot/stdout.expected
732 50b0790e 2020-09-11 stsp cmp -s $testroot/stdout.expected $testroot/stdout
733 50b0790e 2020-09-11 stsp ret="$?"
734 50b0790e 2020-09-11 stsp if [ "$ret" != "0" ]; then
735 50b0790e 2020-09-11 stsp diff -u $testroot/stdout.expected $testroot/stdout
736 50b0790e 2020-09-11 stsp fi
737 50b0790e 2020-09-11 stsp test_done "$testroot" "$ret"
738 50b0790e 2020-09-11 stsp }
739 50b0790e 2020-09-11 stsp
740 f6cae3ed 2020-09-13 naddy test_commit_gotconfig_worktree_author() {
741 50b0790e 2020-09-11 stsp local testroot=`test_init commit_gotconfig_worktree_author`
742 50b0790e 2020-09-11 stsp
743 50b0790e 2020-09-11 stsp got checkout $testroot/repo $testroot/wt > /dev/null
744 50b0790e 2020-09-11 stsp ret="$?"
745 50b0790e 2020-09-11 stsp if [ "$ret" != "0" ]; then
746 50b0790e 2020-09-11 stsp test_done "$testroot" "$ret"
747 50b0790e 2020-09-11 stsp return 1
748 50b0790e 2020-09-11 stsp fi
749 50b0790e 2020-09-11 stsp echo 'author "Flan Luck <flan_luck@openbsd.org>"' \
750 50b0790e 2020-09-11 stsp > $testroot/repo/.git/got.conf
751 50b0790e 2020-09-11 stsp echo 'author "Flan Squee <flan_squee@openbsd.org>"' \
752 50b0790e 2020-09-11 stsp > $testroot/wt/.got/got.conf
753 50b0790e 2020-09-11 stsp
754 50b0790e 2020-09-11 stsp echo "modified alpha" > $testroot/wt/alpha
755 50b0790e 2020-09-11 stsp (cd $testroot/wt && got commit -m 'test gotconfig author' > /dev/null)
756 50b0790e 2020-09-11 stsp ret="$?"
757 50b0790e 2020-09-11 stsp if [ "$ret" != "0" ]; then
758 50b0790e 2020-09-11 stsp test_done "$testroot" "$ret"
759 50b0790e 2020-09-11 stsp return 1
760 50b0790e 2020-09-11 stsp fi
761 50b0790e 2020-09-11 stsp
762 50b0790e 2020-09-11 stsp (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
763 50b0790e 2020-09-11 stsp ret="$?"
764 50b0790e 2020-09-11 stsp if [ "$ret" != "0" ]; then
765 50b0790e 2020-09-11 stsp test_done "$testroot" "$ret"
766 50b0790e 2020-09-11 stsp return 1
767 50b0790e 2020-09-11 stsp fi
768 50b0790e 2020-09-11 stsp
769 50b0790e 2020-09-11 stsp echo "from: Flan Squee <flan_squee@openbsd.org>" \
770 257add31 2020-09-09 stsp > $testroot/stdout.expected
771 257add31 2020-09-09 stsp cmp -s $testroot/stdout.expected $testroot/stdout
772 6af1ccbd 2019-08-16 stsp ret="$?"
773 257add31 2020-09-09 stsp if [ "$ret" != "0" ]; then
774 257add31 2020-09-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
775 257add31 2020-09-09 stsp fi
776 6af1ccbd 2019-08-16 stsp test_done "$testroot" "$ret"
777 6af1ccbd 2019-08-16 stsp }
778 aba9c984 2019-09-08 stsp
779 f6cae3ed 2020-09-13 naddy test_commit_gitconfig_author() {
780 aba9c984 2019-09-08 stsp local testroot=`test_init commit_gitconfig_author`
781 84792843 2019-08-09 stsp
782 aba9c984 2019-09-08 stsp got checkout $testroot/repo $testroot/wt > /dev/null
783 aba9c984 2019-09-08 stsp ret="$?"
784 aba9c984 2019-09-08 stsp if [ "$ret" != "0" ]; then
785 aba9c984 2019-09-08 stsp test_done "$testroot" "$ret"
786 aba9c984 2019-09-08 stsp return 1
787 aba9c984 2019-09-08 stsp fi
788 aba9c984 2019-09-08 stsp
789 aba9c984 2019-09-08 stsp (cd $testroot/repo && git config user.name 'Flan Luck')
790 aba9c984 2019-09-08 stsp (cd $testroot/repo && git config user.email 'flan_luck@openbsd.org')
791 aba9c984 2019-09-08 stsp
792 aba9c984 2019-09-08 stsp echo "modified alpha" > $testroot/wt/alpha
793 aba9c984 2019-09-08 stsp (cd $testroot/wt && got commit -m 'test gitconfig author' > /dev/null)
794 aba9c984 2019-09-08 stsp ret="$?"
795 aba9c984 2019-09-08 stsp if [ "$ret" != "0" ]; then
796 aba9c984 2019-09-08 stsp test_done "$testroot" "$ret"
797 aba9c984 2019-09-08 stsp return 1
798 aba9c984 2019-09-08 stsp fi
799 aba9c984 2019-09-08 stsp
800 aba9c984 2019-09-08 stsp (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
801 aba9c984 2019-09-08 stsp ret="$?"
802 aba9c984 2019-09-08 stsp if [ "$ret" != "0" ]; then
803 aba9c984 2019-09-08 stsp test_done "$testroot" "$ret"
804 aba9c984 2019-09-08 stsp return 1
805 aba9c984 2019-09-08 stsp fi
806 aba9c984 2019-09-08 stsp
807 aba9c984 2019-09-08 stsp echo "from: Flan Luck <flan_luck@openbsd.org>" \
808 aba9c984 2019-09-08 stsp > $testroot/stdout.expected
809 aba9c984 2019-09-08 stsp cmp -s $testroot/stdout.expected $testroot/stdout
810 aba9c984 2019-09-08 stsp ret="$?"
811 aba9c984 2019-09-08 stsp if [ "$ret" != "0" ]; then
812 aba9c984 2019-09-08 stsp diff -u $testroot/stdout.expected $testroot/stdout
813 aba9c984 2019-09-08 stsp fi
814 aba9c984 2019-09-08 stsp test_done "$testroot" "$ret"
815 aba9c984 2019-09-08 stsp }
816 1ebedb77 2019-10-19 stsp
817 f6cae3ed 2020-09-13 naddy test_commit_xbit_change() {
818 1ebedb77 2019-10-19 stsp local testroot=`test_init commit_xbit_change`
819 1ebedb77 2019-10-19 stsp
820 1ebedb77 2019-10-19 stsp got checkout $testroot/repo $testroot/wt > /dev/null
821 1ebedb77 2019-10-19 stsp ret="$?"
822 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
823 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
824 1ebedb77 2019-10-19 stsp return 1
825 1ebedb77 2019-10-19 stsp fi
826 1ebedb77 2019-10-19 stsp
827 1ebedb77 2019-10-19 stsp chmod +x $testroot/wt/alpha
828 1ebedb77 2019-10-19 stsp
829 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
830 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got status > $testroot/stdout)
831 aba9c984 2019-09-08 stsp
832 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
833 1ebedb77 2019-10-19 stsp ret="$?"
834 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
835 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
836 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
837 1ebedb77 2019-10-19 stsp return 1
838 1ebedb77 2019-10-19 stsp fi
839 1ebedb77 2019-10-19 stsp
840 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got commit -mx > $testroot/stdout)
841 1ebedb77 2019-10-19 stsp ret="$?"
842 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
843 1ebedb77 2019-10-19 stsp echo "got commit failed unexpectedly"
844 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
845 1ebedb77 2019-10-19 stsp return 1
846 1ebedb77 2019-10-19 stsp fi
847 1ebedb77 2019-10-19 stsp
848 1ebedb77 2019-10-19 stsp local commit_id=`git_show_head $testroot/repo`
849 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
850 1ebedb77 2019-10-19 stsp echo "Created commit $commit_id" >> $testroot/stdout.expected
851 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
852 1ebedb77 2019-10-19 stsp ret="$?"
853 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
854 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
855 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
856 1ebedb77 2019-10-19 stsp return 1
857 1ebedb77 2019-10-19 stsp fi
858 1ebedb77 2019-10-19 stsp
859 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got status > $testroot/stdout)
860 1ebedb77 2019-10-19 stsp
861 1ebedb77 2019-10-19 stsp echo -n > $testroot/stdout.expected
862 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
863 1ebedb77 2019-10-19 stsp ret="$?"
864 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
865 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
866 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
867 1ebedb77 2019-10-19 stsp return 1
868 1ebedb77 2019-10-19 stsp fi
869 1ebedb77 2019-10-19 stsp
870 1ebedb77 2019-10-19 stsp chmod -x $testroot/wt/alpha
871 1ebedb77 2019-10-19 stsp
872 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
873 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got status > $testroot/stdout)
874 1ebedb77 2019-10-19 stsp
875 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
876 1ebedb77 2019-10-19 stsp ret="$?"
877 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
878 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
879 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
880 1ebedb77 2019-10-19 stsp return 1
881 1ebedb77 2019-10-19 stsp fi
882 1ebedb77 2019-10-19 stsp
883 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got commit -mx > $testroot/stdout)
884 1ebedb77 2019-10-19 stsp ret="$?"
885 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
886 1ebedb77 2019-10-19 stsp echo "got commit failed unexpectedly"
887 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
888 1ebedb77 2019-10-19 stsp return 1
889 1ebedb77 2019-10-19 stsp fi
890 1ebedb77 2019-10-19 stsp
891 1ebedb77 2019-10-19 stsp local commit_id=`git_show_head $testroot/repo`
892 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
893 1ebedb77 2019-10-19 stsp echo "Created commit $commit_id" >> $testroot/stdout.expected
894 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
895 1ebedb77 2019-10-19 stsp ret="$?"
896 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
897 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
898 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
899 1ebedb77 2019-10-19 stsp return 1
900 1ebedb77 2019-10-19 stsp fi
901 1ebedb77 2019-10-19 stsp
902 1ebedb77 2019-10-19 stsp chmod +x $testroot/wt/alpha
903 1ebedb77 2019-10-19 stsp
904 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
905 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got status > $testroot/stdout)
906 f7b97ccb 2020-04-14 stsp
907 f7b97ccb 2020-04-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
908 f7b97ccb 2020-04-14 stsp ret="$?"
909 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
910 f7b97ccb 2020-04-14 stsp diff -u $testroot/stdout.expected $testroot/stdout
911 f7b97ccb 2020-04-14 stsp fi
912 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
913 f7b97ccb 2020-04-14 stsp }
914 f7b97ccb 2020-04-14 stsp
915 f6cae3ed 2020-09-13 naddy commit_check_mode() {
916 f7b97ccb 2020-04-14 stsp local mode="$1"
917 f7b97ccb 2020-04-14 stsp local expected_mode="$2"
918 f7b97ccb 2020-04-14 stsp
919 f7b97ccb 2020-04-14 stsp chmod 644 $testroot/wt/alpha
920 f7b97ccb 2020-04-14 stsp echo a >> $testroot/wt/alpha
921 f7b97ccb 2020-04-14 stsp chmod $mode $testroot/wt/alpha
922 f7b97ccb 2020-04-14 stsp
923 f7b97ccb 2020-04-14 stsp (cd $testroot/wt && got commit -mm > $testroot/stdout)
924 f7b97ccb 2020-04-14 stsp ret="$?"
925 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
926 f7b97ccb 2020-04-14 stsp echo "got commit failed unexpectedly"
927 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
928 f7b97ccb 2020-04-14 stsp return 1
929 f7b97ccb 2020-04-14 stsp fi
930 1ebedb77 2019-10-19 stsp
931 f7b97ccb 2020-04-14 stsp local commit_id=`git_show_head $testroot/repo`
932 f7b97ccb 2020-04-14 stsp echo 'M alpha' > $testroot/stdout.expected
933 f7b97ccb 2020-04-14 stsp echo "Created commit $commit_id" >> $testroot/stdout.expected
934 f7b97ccb 2020-04-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
935 f7b97ccb 2020-04-14 stsp ret="$?"
936 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
937 f7b97ccb 2020-04-14 stsp diff -u $testroot/stdout.expected $testroot/stdout
938 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
939 a9662115 2021-08-29 naddy return 1
940 f7b97ccb 2020-04-14 stsp fi
941 f7b97ccb 2020-04-14 stsp
942 f7b97ccb 2020-04-14 stsp local tree_id=$(got cat -r $testroot/repo $commit_id | \
943 f7b97ccb 2020-04-14 stsp grep ^tree | cut -d' ' -f2)
944 f7b97ccb 2020-04-14 stsp local alpha_id=$(got cat -r $testroot/repo $tree_id | \
945 f7b97ccb 2020-04-14 stsp grep 'alpha$' | cut -d' ' -f1)
946 f7b97ccb 2020-04-14 stsp echo "$alpha_id $expected_mode alpha" > $testroot/stdout.expected
947 f7b97ccb 2020-04-14 stsp got cat -r $testroot/repo $tree_id | grep 'alpha$' > $testroot/stdout
948 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
949 1ebedb77 2019-10-19 stsp ret="$?"
950 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
951 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
952 1ebedb77 2019-10-19 stsp fi
953 f7b97ccb 2020-04-14 stsp return $ret
954 f7b97ccb 2020-04-14 stsp }
955 f7b97ccb 2020-04-14 stsp
956 f6cae3ed 2020-09-13 naddy test_commit_normalizes_filemodes() {
957 f7b97ccb 2020-04-14 stsp local testroot=`test_init commit_normalizes_filemodes`
958 f7b97ccb 2020-04-14 stsp
959 f7b97ccb 2020-04-14 stsp got checkout $testroot/repo $testroot/wt > /dev/null
960 f7b97ccb 2020-04-14 stsp ret="$?"
961 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
962 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
963 f7b97ccb 2020-04-14 stsp return 1
964 f7b97ccb 2020-04-14 stsp fi
965 f7b97ccb 2020-04-14 stsp
966 f7b97ccb 2020-04-14 stsp modes="600 400 460 640 440 660 444 666"
967 f7b97ccb 2020-04-14 stsp for m in $modes; do
968 f7b97ccb 2020-04-14 stsp commit_check_mode "$m" "0100644"
969 cb35d58a 2020-04-14 stsp ret="$?"
970 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
971 f7b97ccb 2020-04-14 stsp break
972 f7b97ccb 2020-04-14 stsp fi
973 f7b97ccb 2020-04-14 stsp done
974 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
975 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
976 f7b97ccb 2020-04-14 stsp return 1
977 f7b97ccb 2020-04-14 stsp fi
978 f7b97ccb 2020-04-14 stsp modes="700 500 570 750 550 770 555 777"
979 f7b97ccb 2020-04-14 stsp for m in $modes; do
980 f7b97ccb 2020-04-14 stsp commit_check_mode "$m" "0100755"
981 cb35d58a 2020-04-14 stsp ret="$?"
982 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
983 f7b97ccb 2020-04-14 stsp break
984 f7b97ccb 2020-04-14 stsp fi
985 f7b97ccb 2020-04-14 stsp done
986 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
987 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
988 e7303626 2020-05-14 stsp return 1
989 e7303626 2020-05-14 stsp fi
990 e7303626 2020-05-14 stsp test_done "$testroot" "$ret"
991 e7303626 2020-05-14 stsp }
992 e7303626 2020-05-14 stsp
993 f6cae3ed 2020-09-13 naddy test_commit_with_unrelated_submodule() {
994 e7303626 2020-05-14 stsp local testroot=`test_init commit_with_unrelated_submodule`
995 e7303626 2020-05-14 stsp
996 e7303626 2020-05-14 stsp make_single_file_repo $testroot/repo2 foo
997 e7303626 2020-05-14 stsp
998 e7303626 2020-05-14 stsp (cd $testroot/repo && git submodule -q add ../repo2)
999 e7303626 2020-05-14 stsp (cd $testroot/repo && git commit -q -m 'adding submodule')
1000 e7303626 2020-05-14 stsp
1001 e7303626 2020-05-14 stsp got checkout $testroot/repo $testroot/wt > /dev/null
1002 e7303626 2020-05-14 stsp ret="$?"
1003 e7303626 2020-05-14 stsp if [ "$ret" != "0" ]; then
1004 7aadece8 2020-05-17 stsp echo "checkout failed unexpectedly" >&2
1005 e7303626 2020-05-14 stsp test_done "$testroot" "$ret"
1006 e7303626 2020-05-14 stsp return 1
1007 e7303626 2020-05-14 stsp fi
1008 e7303626 2020-05-14 stsp
1009 e7303626 2020-05-14 stsp echo "modified alpha" > $testroot/wt/alpha
1010 e7303626 2020-05-14 stsp
1011 7aadece8 2020-05-17 stsp echo "" > $testroot/stdout.expected
1012 7aadece8 2020-05-17 stsp
1013 74ad335c 2020-06-23 stsp (cd $testroot/wt && got commit -m 'modify alpha' > $testroot/stdout)
1014 e7303626 2020-05-14 stsp ret="$?"
1015 7aadece8 2020-05-17 stsp if [ "$ret" != "0" ]; then
1016 7aadece8 2020-05-17 stsp echo "commit failed unexpectedly" >&2
1017 7aadece8 2020-05-17 stsp test_done "$testroot" "$ret"
1018 f7b97ccb 2020-04-14 stsp return 1
1019 f7b97ccb 2020-04-14 stsp fi
1020 e7303626 2020-05-14 stsp
1021 7aadece8 2020-05-17 stsp local head_rev=`git_show_head $testroot/repo`
1022 7aadece8 2020-05-17 stsp echo "M alpha" > $testroot/stdout.expected
1023 7aadece8 2020-05-17 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
1024 3d9a4ec4 2020-07-23 stsp
1025 3d9a4ec4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1026 3d9a4ec4 2020-07-23 stsp ret="$?"
1027 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1028 3d9a4ec4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1029 3d9a4ec4 2020-07-23 stsp fi
1030 3d9a4ec4 2020-07-23 stsp test_done "$testroot" "$ret"
1031 3d9a4ec4 2020-07-23 stsp }
1032 3d9a4ec4 2020-07-23 stsp
1033 f6cae3ed 2020-09-13 naddy check_symlinks() {
1034 bd6aa359 2020-07-23 stsp local wtpath="$1"
1035 bd6aa359 2020-07-23 stsp if ! [ -h $wtpath/alpha.link ]; then
1036 bd6aa359 2020-07-23 stsp echo "alpha.link is not a symlink"
1037 bd6aa359 2020-07-23 stsp return 1
1038 bd6aa359 2020-07-23 stsp fi
1039 3d9a4ec4 2020-07-23 stsp
1040 bd6aa359 2020-07-23 stsp readlink $wtpath/alpha.link > $testroot/stdout
1041 bd6aa359 2020-07-23 stsp echo "alpha" > $testroot/stdout.expected
1042 bd6aa359 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1043 3d9a4ec4 2020-07-23 stsp ret="$?"
1044 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1045 bd6aa359 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1046 3d9a4ec4 2020-07-23 stsp return 1
1047 3d9a4ec4 2020-07-23 stsp fi
1048 3d9a4ec4 2020-07-23 stsp
1049 bd6aa359 2020-07-23 stsp if ! [ -h $wtpath/epsilon.link ]; then
1050 bd6aa359 2020-07-23 stsp echo "epsilon.link is not a symlink"
1051 bd6aa359 2020-07-23 stsp return 1
1052 bd6aa359 2020-07-23 stsp fi
1053 3d9a4ec4 2020-07-23 stsp
1054 bd6aa359 2020-07-23 stsp readlink $wtpath/epsilon.link > $testroot/stdout
1055 bd6aa359 2020-07-23 stsp echo "epsilon" > $testroot/stdout.expected
1056 3d9a4ec4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1057 3d9a4ec4 2020-07-23 stsp ret="$?"
1058 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1059 3d9a4ec4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1060 3d9a4ec4 2020-07-23 stsp return 1
1061 3d9a4ec4 2020-07-23 stsp fi
1062 3d9a4ec4 2020-07-23 stsp
1063 bd6aa359 2020-07-23 stsp if [ -h $wtpath/passwd.link ]; then
1064 bd6aa359 2020-07-23 stsp echo -n "passwd.link is a symlink and points outside of work tree: " >&2
1065 bd6aa359 2020-07-23 stsp readlink $wtpath/passwd.link >&2
1066 bd6aa359 2020-07-23 stsp return 1
1067 bd6aa359 2020-07-23 stsp fi
1068 bd6aa359 2020-07-23 stsp
1069 bd6aa359 2020-07-23 stsp echo -n "/etc/passwd" > $testroot/content.expected
1070 bd6aa359 2020-07-23 stsp cp $wtpath/passwd.link $testroot/content
1071 3d9a4ec4 2020-07-23 stsp ret="$?"
1072 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1073 bd6aa359 2020-07-23 stsp echo "cp command failed unexpectedly" >&2
1074 3d9a4ec4 2020-07-23 stsp return 1
1075 3d9a4ec4 2020-07-23 stsp fi
1076 3d9a4ec4 2020-07-23 stsp
1077 bd6aa359 2020-07-23 stsp cmp -s $testroot/content.expected $testroot/content
1078 bd6aa359 2020-07-23 stsp ret="$?"
1079 bd6aa359 2020-07-23 stsp if [ "$ret" != "0" ]; then
1080 bd6aa359 2020-07-23 stsp diff -u $testroot/content.expected $testroot/content
1081 3d9a4ec4 2020-07-23 stsp return 1
1082 3d9a4ec4 2020-07-23 stsp fi
1083 3d9a4ec4 2020-07-23 stsp
1084 bd6aa359 2020-07-23 stsp readlink $wtpath/epsilon/beta.link > $testroot/stdout
1085 bd6aa359 2020-07-23 stsp echo "../beta" > $testroot/stdout.expected
1086 3d9a4ec4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1087 3d9a4ec4 2020-07-23 stsp ret="$?"
1088 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1089 3d9a4ec4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1090 3d9a4ec4 2020-07-23 stsp return 1
1091 3d9a4ec4 2020-07-23 stsp fi
1092 7aadece8 2020-05-17 stsp
1093 bd6aa359 2020-07-23 stsp readlink $wtpath/nonexistent.link > $testroot/stdout
1094 bd6aa359 2020-07-23 stsp echo "nonexistent" > $testroot/stdout.expected
1095 7aadece8 2020-05-17 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1096 e7303626 2020-05-14 stsp ret="$?"
1097 e7303626 2020-05-14 stsp if [ "$ret" != "0" ]; then
1098 7aadece8 2020-05-17 stsp diff -u $testroot/stdout.expected $testroot/stdout
1099 3d9a4ec4 2020-07-23 stsp return 1
1100 e7303626 2020-05-14 stsp fi
1101 3d9a4ec4 2020-07-23 stsp
1102 bd6aa359 2020-07-23 stsp return 0
1103 bd6aa359 2020-07-23 stsp }
1104 3d9a4ec4 2020-07-23 stsp
1105 f6cae3ed 2020-09-13 naddy test_commit_symlink() {
1106 bd6aa359 2020-07-23 stsp local testroot=`test_init commit_symlink`
1107 3d9a4ec4 2020-07-23 stsp
1108 bd6aa359 2020-07-23 stsp got checkout $testroot/repo $testroot/wt > /dev/null
1109 3d9a4ec4 2020-07-23 stsp ret="$?"
1110 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1111 3d9a4ec4 2020-07-23 stsp test_done "$testroot" "$ret"
1112 3d9a4ec4 2020-07-23 stsp return 1
1113 3d9a4ec4 2020-07-23 stsp fi
1114 3d9a4ec4 2020-07-23 stsp
1115 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s alpha alpha.link)
1116 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s epsilon epsilon.link)
1117 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s /etc/passwd passwd.link)
1118 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s ../beta epsilon/beta.link)
1119 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s nonexistent nonexistent.link)
1120 bd6aa359 2020-07-23 stsp (cd $testroot/wt && got add alpha.link epsilon.link passwd.link \
1121 bd6aa359 2020-07-23 stsp epsilon/beta.link nonexistent.link > /dev/null)
1122 bd6aa359 2020-07-23 stsp
1123 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -m 'test commit_symlink' \
1124 35213c7c 2020-07-23 stsp > $testroot/stdout 2> $testroot/stderr)
1125 35213c7c 2020-07-23 stsp ret="$?"
1126 54c39596 2020-12-28 stsp if [ "$ret" = "0" ]; then
1127 35213c7c 2020-07-23 stsp echo "got commit succeeded unexpectedly" >&2
1128 35213c7c 2020-07-23 stsp test_done "$testroot" "$ret"
1129 35213c7c 2020-07-23 stsp return 1
1130 35213c7c 2020-07-23 stsp fi
1131 35213c7c 2020-07-23 stsp echo -n "got: $testroot/wt/passwd.link: " > $testroot/stderr.expected
1132 35213c7c 2020-07-23 stsp echo "symbolic link points outside of paths under version control" \
1133 35213c7c 2020-07-23 stsp >> $testroot/stderr.expected
1134 35213c7c 2020-07-23 stsp cmp -s $testroot/stderr.expected $testroot/stderr
1135 35213c7c 2020-07-23 stsp ret="$?"
1136 35213c7c 2020-07-23 stsp if [ "$ret" != "0" ]; then
1137 35213c7c 2020-07-23 stsp diff -u $testroot/stderr.expected $testroot/stderr
1138 35213c7c 2020-07-23 stsp test_done "$testroot" "$ret"
1139 35213c7c 2020-07-23 stsp return 1
1140 35213c7c 2020-07-23 stsp fi
1141 bd6aa359 2020-07-23 stsp
1142 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -S -m 'test commit_symlink' \
1143 35213c7c 2020-07-23 stsp > $testroot/stdout)
1144 35213c7c 2020-07-23 stsp
1145 bd6aa359 2020-07-23 stsp local head_rev=`git_show_head $testroot/repo`
1146 bd6aa359 2020-07-23 stsp echo "A alpha.link" > $testroot/stdout.expected
1147 bd6aa359 2020-07-23 stsp echo "A epsilon.link" >> $testroot/stdout.expected
1148 bd6aa359 2020-07-23 stsp echo "A nonexistent.link" >> $testroot/stdout.expected
1149 bd6aa359 2020-07-23 stsp echo "A passwd.link" >> $testroot/stdout.expected
1150 bd6aa359 2020-07-23 stsp echo "A epsilon/beta.link" >> $testroot/stdout.expected
1151 bd6aa359 2020-07-23 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
1152 bd6aa359 2020-07-23 stsp
1153 3d9a4ec4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1154 3d9a4ec4 2020-07-23 stsp ret="$?"
1155 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1156 3d9a4ec4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1157 3d9a4ec4 2020-07-23 stsp test_done "$testroot" "$ret"
1158 3d9a4ec4 2020-07-23 stsp return 1
1159 3d9a4ec4 2020-07-23 stsp fi
1160 3d9a4ec4 2020-07-23 stsp
1161 bd6aa359 2020-07-23 stsp # verify created in-repository tree
1162 bd6aa359 2020-07-23 stsp got checkout $testroot/repo $testroot/wt2 > /dev/null
1163 3d9a4ec4 2020-07-23 stsp ret="$?"
1164 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1165 bd6aa359 2020-07-23 stsp test_done "$testroot" "$ret"
1166 bd6aa359 2020-07-23 stsp return 1
1167 3d9a4ec4 2020-07-23 stsp fi
1168 bd6aa359 2020-07-23 stsp check_symlinks $testroot/wt2
1169 bd6aa359 2020-07-23 stsp ret="$?"
1170 bd6aa359 2020-07-23 stsp if [ "$ret" != "0" ]; then
1171 bd6aa359 2020-07-23 stsp test_done "$testroot" "$ret"
1172 bd6aa359 2020-07-23 stsp return 1
1173 bd6aa359 2020-07-23 stsp fi
1174 bd6aa359 2020-07-23 stsp
1175 75f0a0fb 2020-07-23 stsp if ! [ -h $testroot/wt/passwd.link ]; then
1176 75f0a0fb 2020-07-23 stsp echo 'passwd.link is not a symlink' >&2
1177 75f0a0fb 2020-07-23 stsp test_done "$testroot" 1
1178 75f0a0fb 2020-07-23 stsp return 1
1179 75f0a0fb 2020-07-23 stsp fi
1180 75f0a0fb 2020-07-23 stsp
1181 75f0a0fb 2020-07-23 stsp # 'got update' should reinstall passwd.link as a regular file
1182 75f0a0fb 2020-07-23 stsp (cd $testroot/wt && got update > /dev/null)
1183 bd6aa359 2020-07-23 stsp check_symlinks $testroot/wt
1184 5a1fbc73 2020-07-23 stsp ret="$?"
1185 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1186 5a1fbc73 2020-07-23 stsp test_done "$testroot" "$ret"
1187 5a1fbc73 2020-07-23 stsp return 1
1188 5a1fbc73 2020-07-23 stsp fi
1189 88fb31d4 2020-07-23 stsp
1190 88fb31d4 2020-07-23 stsp (cd $testroot/wt && ln -sf beta alpha.link)
1191 dd6165e4 2021-09-21 thomas.ad (cd $testroot/wt && ln -sfT gamma epsilon.link)
1192 88fb31d4 2020-07-23 stsp rm $testroot/wt/epsilon/beta.link
1193 88fb31d4 2020-07-23 stsp echo "this is a regular file" > $testroot/wt/epsilon/beta.link
1194 88fb31d4 2020-07-23 stsp (cd $testroot/wt && ln -sf .got/bar dotgotbar.link)
1195 35213c7c 2020-07-23 stsp (cd $testroot/wt && got add dotgotbar.link > /dev/null)
1196 88fb31d4 2020-07-23 stsp (cd $testroot/wt && got rm nonexistent.link > /dev/null)
1197 88fb31d4 2020-07-23 stsp (cd $testroot/wt && ln -sf gamma/delta zeta.link)
1198 88fb31d4 2020-07-23 stsp (cd $testroot/wt && ln -sf alpha new.link)
1199 88fb31d4 2020-07-23 stsp (cd $testroot/wt && got add new.link > /dev/null)
1200 88fb31d4 2020-07-23 stsp
1201 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -m 'test commit_symlink' \
1202 35213c7c 2020-07-23 stsp > $testroot/stdout 2> $testroot/stderr)
1203 35213c7c 2020-07-23 stsp ret="$?"
1204 54c39596 2020-12-28 stsp if [ "$ret" = "0" ]; then
1205 35213c7c 2020-07-23 stsp echo "got commit succeeded unexpectedly" >&2
1206 35213c7c 2020-07-23 stsp test_done "$testroot" "$ret"
1207 35213c7c 2020-07-23 stsp return 1
1208 35213c7c 2020-07-23 stsp fi
1209 35213c7c 2020-07-23 stsp echo -n "got: $testroot/wt/dotgotbar.link: " > $testroot/stderr.expected
1210 35213c7c 2020-07-23 stsp echo "symbolic link points outside of paths under version control" \
1211 35213c7c 2020-07-23 stsp >> $testroot/stderr.expected
1212 35213c7c 2020-07-23 stsp cmp -s $testroot/stderr.expected $testroot/stderr
1213 35213c7c 2020-07-23 stsp ret="$?"
1214 35213c7c 2020-07-23 stsp if [ "$ret" != "0" ]; then
1215 35213c7c 2020-07-23 stsp diff -u $testroot/stderr.expected $testroot/stderr
1216 35213c7c 2020-07-23 stsp test_done "$testroot" "$ret"
1217 35213c7c 2020-07-23 stsp return 1
1218 35213c7c 2020-07-23 stsp fi
1219 88fb31d4 2020-07-23 stsp
1220 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -S -m 'test commit_symlink' \
1221 35213c7c 2020-07-23 stsp > $testroot/stdout)
1222 35213c7c 2020-07-23 stsp
1223 88fb31d4 2020-07-23 stsp local head_rev=`git_show_head $testroot/repo`
1224 35213c7c 2020-07-23 stsp echo "A dotgotbar.link" > $testroot/stdout.expected
1225 35213c7c 2020-07-23 stsp echo "A new.link" >> $testroot/stdout.expected
1226 88fb31d4 2020-07-23 stsp echo "M alpha.link" >> $testroot/stdout.expected
1227 88fb31d4 2020-07-23 stsp echo "M epsilon/beta.link" >> $testroot/stdout.expected
1228 88fb31d4 2020-07-23 stsp echo "M epsilon.link" >> $testroot/stdout.expected
1229 88fb31d4 2020-07-23 stsp echo "D nonexistent.link" >> $testroot/stdout.expected
1230 88fb31d4 2020-07-23 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
1231 88fb31d4 2020-07-23 stsp
1232 88fb31d4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1233 88fb31d4 2020-07-23 stsp ret="$?"
1234 88fb31d4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1235 88fb31d4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1236 88fb31d4 2020-07-23 stsp test_done "$testroot" "$ret"
1237 88fb31d4 2020-07-23 stsp return 1
1238 88fb31d4 2020-07-23 stsp fi
1239 88fb31d4 2020-07-23 stsp
1240 88fb31d4 2020-07-23 stsp got tree -r $testroot/repo -c $head_rev -R > $testroot/stdout
1241 88fb31d4 2020-07-23 stsp cat > $testroot/stdout.expected <<EOF
1242 88fb31d4 2020-07-23 stsp alpha
1243 88fb31d4 2020-07-23 stsp alpha.link@ -> beta
1244 88fb31d4 2020-07-23 stsp beta
1245 35213c7c 2020-07-23 stsp dotgotbar.link@ -> .got/bar
1246 88fb31d4 2020-07-23 stsp epsilon/
1247 88fb31d4 2020-07-23 stsp epsilon/beta.link
1248 88fb31d4 2020-07-23 stsp epsilon/zeta
1249 88fb31d4 2020-07-23 stsp epsilon.link@ -> gamma
1250 88fb31d4 2020-07-23 stsp gamma/
1251 88fb31d4 2020-07-23 stsp gamma/delta
1252 88fb31d4 2020-07-23 stsp new.link@ -> alpha
1253 88fb31d4 2020-07-23 stsp passwd.link@ -> /etc/passwd
1254 88fb31d4 2020-07-23 stsp EOF
1255 88fb31d4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1256 88fb31d4 2020-07-23 stsp ret="$?"
1257 88fb31d4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1258 88fb31d4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1259 88fb31d4 2020-07-23 stsp fi
1260 88fb31d4 2020-07-23 stsp test_done "$testroot" "$ret"
1261 5a1fbc73 2020-07-23 stsp }
1262 5a1fbc73 2020-07-23 stsp
1263 f6cae3ed 2020-09-13 naddy test_commit_fix_bad_symlink() {
1264 5a1fbc73 2020-07-23 stsp local testroot=`test_init commit_fix_bad_symlink`
1265 5a1fbc73 2020-07-23 stsp
1266 5a1fbc73 2020-07-23 stsp got checkout $testroot/repo $testroot/wt > /dev/null
1267 5a1fbc73 2020-07-23 stsp ret="$?"
1268 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1269 5a1fbc73 2020-07-23 stsp echo "got checkout failed unexpectedly" >&2
1270 5a1fbc73 2020-07-23 stsp test_done "$testroot" "$ret"
1271 5a1fbc73 2020-07-23 stsp return 1
1272 5a1fbc73 2020-07-23 stsp fi
1273 5a1fbc73 2020-07-23 stsp
1274 5a1fbc73 2020-07-23 stsp (cd $testroot/wt && ln -s /etc/passwd passwd.link)
1275 5a1fbc73 2020-07-23 stsp (cd $testroot/wt && got add passwd.link > /dev/null)
1276 5a1fbc73 2020-07-23 stsp
1277 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -S -m 'commit bad symlink' \
1278 35213c7c 2020-07-23 stsp > $testroot/stdout)
1279 5a1fbc73 2020-07-23 stsp
1280 75f0a0fb 2020-07-23 stsp if ! [ -h $testroot/wt/passwd.link ]; then
1281 75f0a0fb 2020-07-23 stsp echo 'passwd.link is not a symlink' >&2
1282 75f0a0fb 2020-07-23 stsp test_done "$testroot" 1
1283 75f0a0fb 2020-07-23 stsp return 1
1284 75f0a0fb 2020-07-23 stsp fi
1285 75f0a0fb 2020-07-23 stsp (cd $testroot/wt && got update >/dev/null)
1286 5a1fbc73 2020-07-23 stsp if [ -h $testroot/wt/passwd.link ]; then
1287 5a1fbc73 2020-07-23 stsp echo "passwd.link is a symlink but should be a regular file" >&2
1288 5a1fbc73 2020-07-23 stsp test_done "$testroot" "1"
1289 5a1fbc73 2020-07-23 stsp return 1
1290 5a1fbc73 2020-07-23 stsp fi
1291 5a1fbc73 2020-07-23 stsp
1292 5a1fbc73 2020-07-23 stsp # create another work tree which will contain the "bad" symlink
1293 5a1fbc73 2020-07-23 stsp got checkout $testroot/repo $testroot/wt2 > /dev/null
1294 5a1fbc73 2020-07-23 stsp ret="$?"
1295 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1296 5a1fbc73 2020-07-23 stsp echo "got checkout failed unexpectedly" >&2
1297 5a1fbc73 2020-07-23 stsp test_done "$testroot" "$ret"
1298 5a1fbc73 2020-07-23 stsp return 1
1299 5a1fbc73 2020-07-23 stsp fi
1300 5a1fbc73 2020-07-23 stsp
1301 5a1fbc73 2020-07-23 stsp # change "bad" symlink back into a "good" symlink
1302 dd6165e4 2021-09-21 thomas.ad (cd $testroot/wt && ln -sfT alpha passwd.link)
1303 5a1fbc73 2020-07-23 stsp
1304 5a1fbc73 2020-07-23 stsp (cd $testroot/wt && got commit -m 'fix bad symlink' \
1305 5a1fbc73 2020-07-23 stsp > $testroot/stdout)
1306 5a1fbc73 2020-07-23 stsp
1307 5a1fbc73 2020-07-23 stsp local head_rev=`git_show_head $testroot/repo`
1308 5a1fbc73 2020-07-23 stsp echo "M passwd.link" > $testroot/stdout.expected
1309 5a1fbc73 2020-07-23 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
1310 5a1fbc73 2020-07-23 stsp
1311 5a1fbc73 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1312 bd6aa359 2020-07-23 stsp ret="$?"
1313 bd6aa359 2020-07-23 stsp if [ "$ret" != "0" ]; then
1314 5a1fbc73 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1315 bd6aa359 2020-07-23 stsp test_done "$testroot" "$ret"
1316 bd6aa359 2020-07-23 stsp return 1
1317 bd6aa359 2020-07-23 stsp fi
1318 5a1fbc73 2020-07-23 stsp
1319 5a1fbc73 2020-07-23 stsp if ! [ -h $testroot/wt/passwd.link ]; then
1320 5a1fbc73 2020-07-23 stsp echo 'passwd.link is not a symlink' >&2
1321 5a1fbc73 2020-07-23 stsp test_done "$testroot" 1
1322 5a1fbc73 2020-07-23 stsp return 1
1323 5a1fbc73 2020-07-23 stsp fi
1324 5a1fbc73 2020-07-23 stsp
1325 5a1fbc73 2020-07-23 stsp readlink $testroot/wt/passwd.link > $testroot/stdout
1326 5a1fbc73 2020-07-23 stsp echo "alpha" > $testroot/stdout.expected
1327 5a1fbc73 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1328 5a1fbc73 2020-07-23 stsp ret="$?"
1329 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1330 5a1fbc73 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1331 5a1fbc73 2020-07-23 stsp return 1
1332 5a1fbc73 2020-07-23 stsp fi
1333 5a1fbc73 2020-07-23 stsp
1334 5a1fbc73 2020-07-23 stsp # Update the other work tree; the bad symlink should be fixed
1335 5a1fbc73 2020-07-23 stsp (cd $testroot/wt2 && got update > /dev/null)
1336 5a1fbc73 2020-07-23 stsp ret="$?"
1337 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1338 5a1fbc73 2020-07-23 stsp echo "got checkout failed unexpectedly" >&2
1339 5a1fbc73 2020-07-23 stsp test_done "$testroot" "$ret"
1340 5a1fbc73 2020-07-23 stsp return 1
1341 5a1fbc73 2020-07-23 stsp fi
1342 5a1fbc73 2020-07-23 stsp
1343 5a1fbc73 2020-07-23 stsp if ! [ -h $testroot/wt2/passwd.link ]; then
1344 5a1fbc73 2020-07-23 stsp echo 'passwd.link is not a symlink' >&2
1345 5a1fbc73 2020-07-23 stsp test_done "$testroot" 1
1346 5a1fbc73 2020-07-23 stsp return 1
1347 5a1fbc73 2020-07-23 stsp fi
1348 5a1fbc73 2020-07-23 stsp
1349 5a1fbc73 2020-07-23 stsp readlink $testroot/wt2/passwd.link > $testroot/stdout
1350 5a1fbc73 2020-07-23 stsp echo "alpha" > $testroot/stdout.expected
1351 5a1fbc73 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1352 5a1fbc73 2020-07-23 stsp ret="$?"
1353 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1354 5a1fbc73 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1355 5a1fbc73 2020-07-23 stsp return 1
1356 5a1fbc73 2020-07-23 stsp fi
1357 5a1fbc73 2020-07-23 stsp
1358 bd6aa359 2020-07-23 stsp test_done "$testroot" "0"
1359 1ebedb77 2019-10-19 stsp }
1360 28cf319f 2021-01-28 stsp
1361 28cf319f 2021-01-28 stsp test_commit_prepared_logmsg() {
1362 28cf319f 2021-01-28 stsp local testroot=`test_init commit_prepared_logmsg`
1363 28cf319f 2021-01-28 stsp
1364 28cf319f 2021-01-28 stsp got checkout $testroot/repo $testroot/wt > /dev/null
1365 28cf319f 2021-01-28 stsp ret="$?"
1366 28cf319f 2021-01-28 stsp if [ "$ret" != "0" ]; then
1367 28cf319f 2021-01-28 stsp test_done "$testroot" "$ret"
1368 28cf319f 2021-01-28 stsp return 1
1369 28cf319f 2021-01-28 stsp fi
1370 28cf319f 2021-01-28 stsp
1371 28cf319f 2021-01-28 stsp echo "modified alpha" > $testroot/wt/alpha
1372 28cf319f 2021-01-28 stsp (cd $testroot/wt && got rm beta >/dev/null)
1373 28cf319f 2021-01-28 stsp echo "new file" > $testroot/wt/new
1374 28cf319f 2021-01-28 stsp (cd $testroot/wt && got add new >/dev/null)
1375 28cf319f 2021-01-28 stsp
1376 28cf319f 2021-01-28 stsp echo 'test commit_prepared_logmsg' > $testroot/logmsg
1377 28cf319f 2021-01-28 stsp
1378 28cf319f 2021-01-28 stsp cat > $testroot/editor.sh <<EOF
1379 28cf319f 2021-01-28 stsp #!/bin/sh
1380 372960fe 2021-10-08 thomas sed -i '' 's/foo/bar/' "\$1"
1381 28cf319f 2021-01-28 stsp EOF
1382 28cf319f 2021-01-28 stsp chmod +x $testroot/editor.sh
1383 28cf319f 2021-01-28 stsp
1384 8e09a168 2021-06-17 tracey (cd $testroot/wt && env VISUAL="$testroot/editor.sh" \
1385 28cf319f 2021-01-28 stsp got commit -F "$testroot/logmsg" > $testroot/stdout)
1386 1ebedb77 2019-10-19 stsp
1387 28cf319f 2021-01-28 stsp local head_rev=`git_show_head $testroot/repo`
1388 28cf319f 2021-01-28 stsp echo "A new" > $testroot/stdout.expected
1389 28cf319f 2021-01-28 stsp echo "M alpha" >> $testroot/stdout.expected
1390 28cf319f 2021-01-28 stsp echo "D beta" >> $testroot/stdout.expected
1391 28cf319f 2021-01-28 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
1392 28cf319f 2021-01-28 stsp
1393 28cf319f 2021-01-28 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1394 28cf319f 2021-01-28 stsp ret="$?"
1395 28cf319f 2021-01-28 stsp if [ "$ret" != "0" ]; then
1396 28cf319f 2021-01-28 stsp diff -u $testroot/stdout.expected $testroot/stdout
1397 28cf319f 2021-01-28 stsp test_done "$testroot" "$ret"
1398 28cf319f 2021-01-28 stsp return 1
1399 28cf319f 2021-01-28 stsp fi
1400 28cf319f 2021-01-28 stsp
1401 28cf319f 2021-01-28 stsp local author_time=`git_show_author_time $testroot/repo`
1402 372960fe 2021-10-08 thomas local prev_LC_TIME="$LC_TIME"
1403 372960fe 2021-10-08 thomas export LC_TIME=C
1404 372960fe 2021-10-08 thomas d=`date -u -d "@$author_time" +"%a %b %e %X %Y UTC"`
1405 372960fe 2021-10-08 thomas LC_TIME="$prev_LC_TIME"
1406 28cf319f 2021-01-28 stsp echo "-----------------------------------------------" > $testroot/stdout.expected
1407 28cf319f 2021-01-28 stsp echo "commit $head_rev (master)" >> $testroot/stdout.expected
1408 28cf319f 2021-01-28 stsp echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
1409 28cf319f 2021-01-28 stsp echo "date: $d" >> $testroot/stdout.expected
1410 28cf319f 2021-01-28 stsp echo " " >> $testroot/stdout.expected
1411 28cf319f 2021-01-28 stsp echo " test commit_prepared_logmsg" >> $testroot/stdout.expected
1412 28cf319f 2021-01-28 stsp echo " " >> $testroot/stdout.expected
1413 28cf319f 2021-01-28 stsp
1414 28cf319f 2021-01-28 stsp (cd $testroot/wt && got log -l 1 > $testroot/stdout)
1415 28cf319f 2021-01-28 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1416 28cf319f 2021-01-28 stsp ret="$?"
1417 28cf319f 2021-01-28 stsp if [ "$ret" != "0" ]; then
1418 28cf319f 2021-01-28 stsp diff -u $testroot/stdout.expected $testroot/stdout
1419 28cf319f 2021-01-28 stsp test_done "$testroot" "$ret"
1420 28cf319f 2021-01-28 stsp return 1
1421 28cf319f 2021-01-28 stsp fi
1422 28cf319f 2021-01-28 stsp
1423 28cf319f 2021-01-28 stsp echo "modified alpha again" > $testroot/wt/alpha
1424 28cf319f 2021-01-28 stsp
1425 28cf319f 2021-01-28 stsp echo 'test commit_prepared_logmsg non-interactive' \
1426 28cf319f 2021-01-28 stsp > $testroot/logmsg
1427 28cf319f 2021-01-28 stsp
1428 28cf319f 2021-01-28 stsp (cd $testroot/wt && got commit -N -F "$testroot/logmsg" \
1429 28cf319f 2021-01-28 stsp > $testroot/stdout)
1430 28cf319f 2021-01-28 stsp
1431 28cf319f 2021-01-28 stsp local head_rev=`git_show_head $testroot/repo`
1432 28cf319f 2021-01-28 stsp echo "M alpha" > $testroot/stdout.expected
1433 28cf319f 2021-01-28 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
1434 28cf319f 2021-01-28 stsp
1435 28cf319f 2021-01-28 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1436 28cf319f 2021-01-28 stsp ret="$?"
1437 28cf319f 2021-01-28 stsp if [ "$ret" != "0" ]; then
1438 28cf319f 2021-01-28 stsp diff -u $testroot/stdout.expected $testroot/stdout
1439 28cf319f 2021-01-28 stsp test_done "$testroot" "$ret"
1440 28cf319f 2021-01-28 stsp return 1
1441 28cf319f 2021-01-28 stsp fi
1442 28cf319f 2021-01-28 stsp
1443 28cf319f 2021-01-28 stsp local author_time=`git_show_author_time $testroot/repo`
1444 372960fe 2021-10-08 thomas local prev_LC_TIME="$LC_TIME"
1445 372960fe 2021-10-08 thomas export LC_TIME=C
1446 372960fe 2021-10-08 thomas d=`date -u -d "@$author_time" +"%a %b %e %X %Y UTC"`
1447 372960fe 2021-10-08 thomas LC_TIME="$prev_LC_TIME"
1448 28cf319f 2021-01-28 stsp echo "-----------------------------------------------" \
1449 28cf319f 2021-01-28 stsp > $testroot/stdout.expected
1450 28cf319f 2021-01-28 stsp echo "commit $head_rev (master)" >> $testroot/stdout.expected
1451 28cf319f 2021-01-28 stsp echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
1452 28cf319f 2021-01-28 stsp echo "date: $d" >> $testroot/stdout.expected
1453 28cf319f 2021-01-28 stsp echo " " >> $testroot/stdout.expected
1454 28cf319f 2021-01-28 stsp echo " test commit_prepared_logmsg non-interactive" \
1455 28cf319f 2021-01-28 stsp >> $testroot/stdout.expected
1456 28cf319f 2021-01-28 stsp echo " " >> $testroot/stdout.expected
1457 28cf319f 2021-01-28 stsp
1458 28cf319f 2021-01-28 stsp (cd $testroot/wt && got log -l 1 > $testroot/stdout)
1459 28cf319f 2021-01-28 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1460 28cf319f 2021-01-28 stsp ret="$?"
1461 28cf319f 2021-01-28 stsp if [ "$ret" != "0" ]; then
1462 28cf319f 2021-01-28 stsp diff -u $testroot/stdout.expected $testroot/stdout
1463 28cf319f 2021-01-28 stsp fi
1464 28cf319f 2021-01-28 stsp test_done "$testroot" "$ret"
1465 28cf319f 2021-01-28 stsp }
1466 28cf319f 2021-01-28 stsp
1467 7fb414ae 2020-08-08 stsp test_parseargs "$@"
1468 c4296144 2019-05-09 stsp run_test test_commit_basic
1469 83a7ae6d 2019-05-10 stsp run_test test_commit_new_subdir
1470 83a7ae6d 2019-05-10 stsp run_test test_commit_subdir
1471 83a7ae6d 2019-05-10 stsp run_test test_commit_single_file
1472 83a7ae6d 2019-05-10 stsp run_test test_commit_out_of_date
1473 8ba6ba2d 2019-05-14 stsp run_test test_commit_added_subdirs
1474 ba580f68 2020-03-22 stsp run_test test_commit_deleted_subdirs
1475 f363d663 2019-05-23 stsp run_test test_commit_rejects_conflicted_file
1476 1a36436d 2019-06-10 stsp run_test test_commit_single_file_multiple
1477 4866d084 2019-07-10 stsp run_test test_commit_added_and_modified_in_same_dir
1478 e0233cea 2019-07-25 stsp run_test test_commit_path_prefix
1479 90e8619e 2019-07-25 stsp run_test test_commit_dir_path
1480 5c1e53bc 2019-07-28 stsp run_test test_commit_selected_paths
1481 916f288c 2019-07-30 stsp run_test test_commit_outside_refs_heads
1482 84792843 2019-08-09 stsp run_test test_commit_no_email
1483 6af1ccbd 2019-08-16 stsp run_test test_commit_tree_entry_sorting
1484 257add31 2020-09-09 stsp run_test test_commit_gotconfig_author
1485 50b0790e 2020-09-11 stsp run_test test_commit_gotconfig_worktree_author
1486 aba9c984 2019-09-08 stsp run_test test_commit_gitconfig_author
1487 1ebedb77 2019-10-19 stsp run_test test_commit_xbit_change
1488 f7b97ccb 2020-04-14 stsp run_test test_commit_normalizes_filemodes
1489 e7303626 2020-05-14 stsp run_test test_commit_with_unrelated_submodule
1490 3d9a4ec4 2020-07-23 stsp run_test test_commit_symlink
1491 5a1fbc73 2020-07-23 stsp run_test test_commit_fix_bad_symlink
1492 28cf319f 2021-01-28 stsp run_test test_commit_prepared_logmsg